function [Xcg,Xcg_ZF] = CG(L_aircraft,Lfa,Lreartb,Lpax_in,OEW,payload_utente,Vmissing,Vunderfloor)

%Variable assignment
Lpax=Lpax_in;
Payload=payload_utente;

%% CG WITHOUT WING POSITIONING
X(1)=Lfa+Lpax/2;            %Passengers position [AIRCRAFT REFERENCE SYSTEM]
W(1)=Payload;               %Passengers weigth

X(2)=L_aircraft/2;          %OEW position [AIRCRAFT REFERENCE SYSTEM]
W(2)=OEW;                   %OEW weigth

rhoLH2=70.8;                %[kg/m3] LH2 density
X(3)=Lfa+Lpax/2;            %Underfloor tank position [AIRCRAFT REFERENCE SYSTEM]
X(4)=Lfa+Lpax+Lreartb/2;    %Rear tank postion [AIRCRAFT REFERENCE SYSTEM]
W(3)=Vunderfloor*rhoLH2;    %Underfloor tank weigth
W(4)=Vmissing*rhoLH2;       %Rear tank weigth


Xcg=sum(X.*W)./sum(W);
Xcg_ZF=sum(X(1:2).*W(1:2))./sum(W(1:2));

disp(' ')
disp('POSITION')
disp(['Passengers:',num2str(X(1)),' m'])
disp(['OEW:',num2str(X(2)),' m'])
disp(['Underfloor Tank:',num2str(X(3)),' m'])
disp(['Rear Tank:',num2str(X(4)),' m'])
disp(' ')
disp('WEIGTH')
disp(['Passengers:',num2str(W(1)),' kg'])
disp(['OEW:',num2str(W(2)),' kg'])
disp(['Underfloor Tank:',num2str(W(3)),' kg'])
disp(['Rear Tank:',num2str(W(4)),' kg'])
disp(' ')
disp('CG ')
disp(['FUEL:',num2str(Xcg),' m'])
disp(['ZERO FUEL:',num2str(Xcg_ZF),' m'])
end

