function [Wfuel,W_supr_medium,Vsup_crs,Vsup_clm,C_scale,choice_supclm,rsub_crs,SFCsub_crs,rsup_crs,SFCsup_crs,rsub_crs_d,SFCsub_crs_d,Vsub_crs_d,...
    r_crs_MA,SFC_crs_MA,V_crs_MA] = FuelWeight(C_HyLH2,MTOW,ISP,SFC,Mach_utente,fl4,fl5,fl6,fl7,fl8,flMA1,flMA2,Vsub_crs,E_sub,E_sup,t4,t6,t8,tMA2,...
    Msub,Msup,choice_MA)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
%OUTPUT:  W_supr_medium (Medium necessary fuel from ground to starting climb and ended supersonic cruise)--> WS_RequirementVerification
%         Vsup_crs (speed supersonic cruise)--> TW_RequirementVerification
%         Vsup_clm (speed supersonic climb)--> TW_RequirementVerification
%         Wfuel (fuel mission)-->Tank_Layer_Sizing.m
%% RAYMER METHOD
% disp('-------------------------------------------------------------------------------------------')
% disp('                                       RAYMER METHOD                                       ')

%% INITIALIZZATION OF VARIABLE TOTAL RANGE
Range_tot=0;

%% WARM UP & TAKE OFF
disp('-------------------------------------------------------------------')
disp('WARM UP & TAKE OFF')

W1W0=0.97; 
Wratio=W1W0;

disp(['Weight ratio: ',num2str(W1W0)])
%% SUBSONIC CLIMB
disp('-------------------------------------------------------------------')
disp('SUBSONIC CLIMB')

W2W1=0.985;
Wratio=Wratio*W2W1;

disp(['Weight ratio: ',num2str(W2W1)])
%% SUBSONIC CRUISE 
disp('-------------------------------------------------------------------')
disp('SUBSONIC CRUISE:')   

disp(' --> SFC Determination <-- ')

disp('Do you want scale by propulsive efficiency the SFC value of statistical analisys?')
disp('1. YES')
disp('2. NO')
C_scale=input('');

%Scale SFC 
if C_scale==1
    
    cruise=1;
    
    [SFC_crs,Vc] = SFCscale(Vsub_crs,fl6,fl5,fl7,fl8,cruise,ISP,SFC,Mach_utente,C_HyLH2,Msup);
    SFCsub_crs=SFC_crs; %[kg/(daN*h)]
    
end


%NO scale of SFC
if C_scale==2
    
disp(' ')
disp('Insert a value of SFC  [mg/Ns]:')
disp('FIGURE 31 shows possible values as a function of Mach and engine typo. ')   
disp('FIGURE 32 shows possible values for jet in cruise. ')

SFC_im=imread('SFC_Mach.png');
figure(31)
imshow(SFC_im)
SFC_t=imread('SFC_table.png');
figure(32)
imshow(SFC_t)

sfc=input('SFC [mg/Ns]');
SFCsub_crs=sfc*1e-6/(10^(-1)*1/3600); %[kg/(daN*h)]

end

% RANGE ESTIMATION 
rsub_crs=Vsub_crs*t4*60; %Range [m]
Range_tot=Range_tot+rsub_crs;

W3W2=exp(-(rsub_crs*SFCsub_crs/(10*3600)*9.81)/(Vsub_crs*E_sub));

% %Scale SFC
% if C_scale==1
%     
% W3W2=exp(-(rsub_crs*SFCsub_crs/(10*3600)*9.81)/(Vsub_crs*E_sub));
% 
% end
% %NO Scale SFC
% if C_scale==2
%     
% W3W2=exp(-(rsub_crs*SFCsub_crs*1e-6*9.81)/(Vsub_crs*E_sub));
% 
% end
Wratio=Wratio*W3W2;
Wratio_ground_supclm=Wratio; % to estimate the necessary fuel from ground to superosnic climb starting

disp(' ')
disp('OUTPUT:')
disp(['SFC ',num2str(SFCsub_crs), 'kg/daN/h'])
disp(['V [Speed] ', num2str(Vsub_crs),' m/s'])
disp(['Range ',num2str(rsub_crs),'m'])
disp(['Weight ratio: ',num2str(W3W2)])

disp('-------------------------------------------------------------------')
%% SUPERSONIC CLIMB 
disp('SUPERSONIC CLIMB:')

    
disp('Choice the method to estimate the weight ratio of this phase: ')
disp('1. Costant value ')
disp('2. Function estimating(RANGE & VELOCITY)')
choice_supclm=input('');

%Constant value
if choice_supclm==1
    
W4W3=0.985;
Vsup_clm=0;

end

%f(RANGE,VELOCITY)
if choice_supclm==2
    
[SFC_climb,Vclimb,rclimb,W4W3] = WeightRatio_RangeSpeed(fl4,fl5,SFC,t4,E_sub,E_sup,Msub,Msup);
SFCsup_clm=SFC_climb;
Vsup_clm=Vclimb;
rsup_clm=rclimb;
Range_tot=Range_tot+rsup_clm;

disp(' ')
disp('OUTPUT:')
disp(['SFC ',num2str(SFCsup_clm), 'kg/daN/h'])
disp(['V [Speed] ', num2str(Vsup_clm),' m/s'])
disp(['Range ',num2str(rsup_clm),'m'])
end
Wratio=Wratio*W4W3;

disp(['Weight ratio: ',num2str(W4W3)])

disp('-------------------------------------------------------------------')

%% SUPERSONIC CRUISE --> APPROSSIMATION: the corresponding descent is considered
disp('SUPERSONIC CRUISE:')
    
%Scale SFC 

if C_scale==1
    
    cruise=2;
    
    [SFC_crs,Vc] = SFCscale(Vsub_crs,fl6,fl5,fl7,fl8,cruise,ISP,SFC,Mach_utente,C_HyLH2,Msup);
    SFCsup_crs=SFC_crs; %[kg/(daN*h])
    Vsup_crs=Vc;
    
end

%NO scale  SFC

if C_scale==2
    
disp(' ')
disp('Insert a value of SFC  [mg/Ns]:')
disp('FIGURE 31 shows possible values as a function of Mach and engine typo. ')   
disp('FIGURE 32 shows possible values for jet in cruise. ')

% SFC_im=imread('SFC_Mach.png');
% figure(31)
% imshow(SFC_im)
% SFC_t=imread('SFC_table.png');
% figure(32)
% imshow(SFC_t)

sfc=input('');
SFCsup_crs=sfc*1e-6/(10^(-1)*3600); %[kg/(daN*h)]


M=Msup;
h_v=fl5:1:fl6;

Vm=0;
contV=0;

for i=1:length(h_v) 
    
h=h_v(i);
[V] = velocity(h,M);%[m/s]
Vm=Vm+[V];
contV=contV+1;

end

Vsup_crs=Vm/contV;

end

%RANGE ESTIMATION
rsup_crs=Vsup_crs*t6*60; %[m]
Range_tot=Range_tot+rsup_crs;

W5W4=exp(-(rsup_crs*SFCsup_crs/(10*3600)*9.81)/(Vsup_crs*E_sup));
% %Scale SFC
% if C_scale==1
%     
%     W5W4=exp(-(rsup_crs*SFCsup_crs/(10*3600)*9.81)/(Vsup_crs*E_sup));
%     
% end
% %NO scale SFC
% if C_scale==2
%     
% W5W4=exp(-(rsup_crs*SFCsup_crs*1e-6*9.81)/(Vsup_crs*E_sup));
% 
% end
Wratio=Wratio*W5W4;
Wratio_ground_supcrs=Wratio; % to estimate the necessary fuel from ground to supersonic cruise ending

disp(' ')
disp('OUTPUT:')
disp(['SFC ',num2str(SFCsup_crs), 'kg/daN/h'])
disp(['V [speed]', num2str(Vsup_crs),' m/s'])
disp(['Range: ',num2str(rsup_crs),'m'])
disp(['Weight ratio: ',num2str(W5W4)])

disp('-------------------------------------------------------------------')
%% SUBSONIC CRUISE --> APPROSSIMATION: the corresponding descent is considered
disp('SUBSONIC CRUISE (descent):')

%Scale SFC 
if C_scale==1
    
    cruise=3;
    
    [SFC_crs,Vc] = SFCscale(Vsub_crs,fl6,fl5,fl7,fl8,cruise,ISP,SFC,Mach_utente,C_HyLH2,Msup);
    SFCsub_crs_d=SFC_crs; %[kg/(daN*h)]
    Vsub_crs_d=Vc;
    
end

%NO scale of SFC
if C_scale==2
    
   disp(' ')
disp('Insert a value of SFC  [mg/Ns]:')
disp('FIGURE 31 shows possible values as a function of Mach and engine typo. ')   
disp('FIGURE 32 shows possible values for jet in cruise. ')

% SFC_im=imread('SFC_Mach.png');
% figure(31)
% imshow(SFC_im)
% SFC_t=imread('SFC_table.png');
% figure(32)
% imshow(SFC_t)

sfc=input('');
SFCsub_crs_d=sfc*1e-6/(10^(-1)*3600); %[kg/(daN*h)]

disp('Insert a value of Mach number to calculate the velocity')
M=input('');
h_v=fl7:-1:fl8;

Vm=0;
contV=0;

for i=1:length(h_v)
    
h=h_v(i);
[V] = velocity(h,M);%[m/s]
Vm=Vm+[V];
contV=contV+1;

end

Vsub_crs_d=Vm/contV;
    
end

%RANGE ESTIMATION
rsub_crs_d=Vsub_crs_d*t8*60; %[m]
Range_tot=Range_tot+rsub_crs_d;

W6W5=exp(-(rsub_crs_d*SFCsub_crs_d/(10*3600)*9.81)/(Vsub_crs_d*E_sub));
% %Scale SFC
% if C_scale==1
%     
% W6W5=exp(-(rsub_crs_d*SFCsub_crs_d/(10*3600)*9.81)/(Vsub_crs_d*E_sub));
% 
% end
% %NO scale SFC
% if C_scale==2
%     
% W6W5=exp(-(rsub_crs_d*SFCsub_crs_d*1e-6*9.81)/(Vsub_crs_d*E_sub));
% 
% end
Wratio=Wratio*W6W5;

disp(' ')
disp('OUTPUT')
disp(['SFC ',num2str(SFCsub_crs_d), 'kg/daN/h'])
disp(['V [Speed]', num2str(Vsub_crs_d),' m/s'])
disp(['Range: ',num2str(rsub_crs_d),'m'])
disp(['Weight ratio: ',num2str(W6W5)])

disp('-------------------------------------------------------------------')
%% MISSED APPROACH
if choice_MA==1 %MISSED APPROACH IMPLEMENTED
    
%% MISSED APPROACH CLIMB
disp('SUBSONIC CLIMB (MISSED APPROACH):')
W7W6=0.985;
Wratio=Wratio*W7W6;
disp(['Weight ratio: ',num2str(W7W6)])

%% MISSED APPROACH CRUISE 
disp(' ')
disp('SUBSONIC CRUISE (MISSED APPROACH):')
 
%Scale SFC 
if C_scale==1
    
    [SFC_crs_MA,V_crs_MA] = SFCscaleMA(fl5,fl6,flMA1,flMA2,ISP,SFC,Mach_utente,C_HyLH2);
    %SFC_crs_MA [kg/(daN*h)]
    
end

%NO scale SFC
if C_scale==2
    
disp(' ')
disp('Insert a value of SFC  [mg/Ns]:')
disp('FIGURE 31 shows possible values as a function of Mach and engine typo. ')   
disp('FIGURE 32 shows possible values for jet in cruise. ')

% SFC_im=imread('SFC_Mach.png');
% figure(31)
% imshow(SFC_im)
% SFC_t=imread('SFC_table.png');
% figure(32)
% imshow(SFC_t)

sfc=input('');
SFC_crs_MA=sfc*1e-6/(10^(-1)*3600); %[kg/daN h]

disp('Insert a value of Mach number to calculate velocity')
M=input('');

if flMA1<=flMA2
    h_v=flMA1:1:flMA2;
else
    h_v=flMA1:-1:flMA2;
end

Vm=0;
contV=0;

for i=1:length(h_v)
    
h=h_v(i);
[V] = velocity(h,M);%[m/s]
Vm=Vm+[V];
contV=contV+1;

end

V_crs_MA=Vm/contV;

close figure 31
close figure 32
end

%RANEG ESTIMATION
r_crs_MA=V_crs_MA*tMA2*60; %[m]
Range_tot=Range_tot+r_crs_MA;

W8W7=exp(-(r_crs_MA*SFC_crs_MA/(10*3600)*9.81)/(V_crs_MA*E_sub));
% Scale SFC
% if C_scale==1
%     
% W8W7=exp(-(r_crs_MA*SFC_crs_MA/(10*3600)*9.81)/(V_crs_MA*E_sub));
% 
% end
% NO scale SFC
% if C_scale==2
%     
% W8W7=exp(-(r_crs_MA*SFC_crs_MA*1e-6*9.81)/(V_crs_MA*E_sub));
% 
% end
Wratio=Wratio*W8W7;

disp(' ')
disp('OUTPUT')
disp(['SFC ',num2str(SFC_crs_MA), 'kg/daN/h'])
disp(['V [Speed]', num2str(V_crs_MA),' m/s'])
disp(['Range: ',num2str(r_crs_MA),'m'])
disp(['Weight ratio: ',num2str(W8W7)])
disp('-------------------------------------------------------------------')



end
if choice_MA==2 %MISSED APPROACH NOT IMPLEMENTED
    if C_scale==2
        close figure 31
        close figure 32
    end
end
%% LANDING
disp('LANDING:')

W9W8=0.995;
Wratio=Wratio*W9W8;

disp(['Weight ratio: ',num2str(W9W8)])

%% TOTAL FUEL WEIGHT
if C_HyLH2==1 %Hydrocrabon
    Wfuel=(1.06*(1-Wratio))*(MTOW*1e3);  %[kg]
end
if C_HyLH2==2 %LH2
    Wfuel=(1.3*(1-Wratio))*(MTOW*1e3);  %[kg]
end


disp('-------------------------------------------------------------------')
disp(['TOTAL Fuel weight: ',num2str(Wfuel),'kg'])

%% RANGE IN PHASE IN WHICH IS POSSIBILE TO CALCULATE

disp(['Partial range: ',num2str(Range_tot),'m'])
%%
Wfuel_gsupclm=(1-Wratio_ground_supclm)*(MTOW*1e3); %Necessary fuel from ground to supersonic climb starting [kg]
Wfuel_gsupcrs=(1-Wratio_ground_supcrs)*(MTOW*1e3); % Necessary fuel from ground  to supersonic cruise ending [kg]
W_supr_medium=(Wfuel_gsupclm+Wfuel_gsupcrs)/2;   %Medium necessary fuel from ground to starting climb and ended supersonic cruise [kg]
%W_supr_medium=Wfuel_gsupcrs;


end

