function [Wfuel,W_supr_medium]=FuelWeigth_Loop(choice_supclm,rsub_crs,SFCsub_crs,Vsub_crs,E_sub,E_sup,Msub,Msup,fl4,fl5,SFC,t4,rsup_crs,...
    SFCsup_crs,Vsup_crs,rsub_crs_d,SFCsub_crs_d,Vsub_crs_d,r_crs_MA,SFC_crs_MA,V_crs_MA,MTOW,choice_MA,C_HyLH2)
%[Wfinal,WsupMC] = FuelWeight_RV(Mi,Mf,R,Witer,SFC,Range_utente,cc, SFC_subcrs,r_subcrs,V_subcrs,E_sub,i,t5, fl4,fl5 ,r_supcrs, SFC_supcrs,V_supcrs,E_sup,r_subcrs_d, SFC_subcrs_d,V_subcrs_d,choice,r_subcrs_MA, SFC_subcrs_MA,V_subcrs_MA,cont)

% INPUT FUNCTION:
%                 1.SUBSONIC CRUISE: cc, SFC_subcrs,r_subcrs,V_subcrs,E_sub
%                 2.SUPERSONIC CLIMB: i,t5, SFC,Range_utente, fl4,fl5 [successivamente da provare con media tra E sub e E super]
%                 3.SUPERSONIC CRUISE: r_supcrs, SFC_supcrs,V_supcrs,E_sup
%                 4.SUBSONIC CRUISE [DESCENT]:r_subcrs_d, SFC_subcrs_d,V_subcrs_d,E_sub
%                 5.SUBSONIC CRUISE [MISSED APPROACH]: choice,r_subcrs_MA, SFC_subcrs_MA,V_subcrs_MA,E_sub
%% 
%close all

%% RAYMER METHOD

%% WARM UP & TAKE OFF

W1W0=0.97; 
Wratio=W1W0;

%% SUBSONIC CLIMB

W2W1=0.985;
Wratio=Wratio*W2W1;


%% SUBSONIC CRUISE   

%INPUT: SFC_subcrs,cc,r_subcrs,V_subcrs,E_sub

W3W2=exp(-(rsub_crs*SFCsub_crs/(10*3600)*9.81)/(Vsub_crs*E_sub));

% %NO Scale SFC
% if C_scale==2
%     
% W3W2=exp(-(rsub_crs*SFCsub_crs*1e-6*9.81)/(Vsub_crs*E_sub));
% 
% end
% 
% %Scale SFC
% if C_scale==1
%     
% W3W2=exp(-(rsub_crs*SFCsub_crs/(10*3600)*9.81)/(Vsub_crs*E_sub));
% 
% end

Wratio=Wratio*W3W2;
Wratio_ground_supclm=Wratio; % to estimate the necessary fuel from ground to superosnic climb starting

%% SUPERSONIC CLIMB 

%INPUT: i,t5, SFC, fl4,fl5 [successivamente da provare con media tra E sub e E super]

%Constant value
if choice_supclm==1
    
W4W3=0.985;
Vsup_clm=0;

end

%f(RANGE,VELOCITY): 
if choice_supclm==2
    
    [SFC_climb,Vclimb,rclimb,W4W3] = WeightRatio_RangeSpeed(fl4,fl5,SFC,t4,E_sub,E_sup,Msub,Msup);
    Vsup_clm=Vclimb;
    
end

Wratio=Wratio*W4W3;


%% SUPERSONIC CRUISE --> APPROSSIMATION: the corresponding descent is considered

%INPUT: r_supcrs, SFC_supcrs,V_supcrs,E_sup

W5W4=exp(-(rsup_crs*SFCsup_crs/(10*3600)*9.81)/(Vsup_crs*E_sup));


%NO scale SFC
% if C_scale==2
%     
% W5W4=exp(-(rsup_crs*SFCsup_crs*1e-6*9.81)/(Vsup_crs*E_sup));
% 
% end
% 
% %Scale SFC
% if C_scale==1
%     
%     W5W4=exp(-(rsup_crs*SFCsup_crs/(10*3600)*9.81)/(Vsup_crs*E_sup));
%     
% end

Wratio=Wratio*W5W4;
Wratio_ground_supcrs=Wratio; % to estimate the necessary fuel from ground to supersonic cruise ending
%% SUBSONIC CRUISE --> APPROSSIMATION: the corresponding descent is considered

%INPUT: r_subcrs_d, SFC_subcrs_d,V_subcrs_d,E_sub
W6W5=exp(-(rsub_crs_d*SFCsub_crs_d/(10*3600)*9.81)/(Vsub_crs_d*E_sub));

%NO scale SFC
% if C_scale==2
%     
% W6W5=exp(-(rsub_crs_d*SFCsub_crs_d*1e-6*9.81)/(Vsub_crs_d*E_sub));
% 
% end
% 
% %Scale SFC
% if C_scale==1
%     
% W6W5=exp(-(rsub_crs_d*SFCsub_crs_d/(10*3600)*9.81)/(Vsub_crs_d*E_sub));
% 
% end

Wratio=Wratio*W6W5;


%% MISSED APPROACH

if choice_MA==1
    
%MISSED APPROACH CLIMB

W7W6=0.985;
Wratio=Wratio*W7W6;


%MISSED APPROACH CRUISE 

%INPUT: r_subcrs_MA, SFC_subcrs_MA,V_subcrs_MA,E_sub
W8W7=exp(-(r_crs_MA*SFC_crs_MA/(10*3600)*9.81)/(V_crs_MA*E_sub));

%NO scale SFC
% if C_scale==2
%     
% W8W7=exp(-(r_crs_MA*SFC_crs_MA*1e-6*9.81)/(V_crs_MA*E_sub));
% 
% end
% 
% %Scale SFC
% if C_scale==1
%     
% W8W7=exp(-(r_crs_MA*SFC_crs_MA/(10*3600)*9.81)/(V_crs_MA*E_sub));
% 
% end

Wratio=Wratio*W8W7;


end

%% LANDING
W9W8=0.995;
Wratio=Wratio*W9W8;

%% TOTAL FUEL WEIGHT

if C_HyLH2==1 %Hydrocrabon
    Wfuel=(1.06*(1-Wratio))*(MTOW*1e3);  %[kg]
end
if C_HyLH2==2 %LH2
    Wfuel=(1.3*(1-Wratio))*(MTOW*1e3);  %[kg]
end

% figure(49)
% hold on
% plot(cont,Wfinal,'*')

Wfuel_gsupclm=(1-Wratio_ground_supclm)*(MTOW*1e3); %Necessary fuel from ground to supersonic climb starting [kg]
Wfuel_gsupcrs=(1-Wratio_ground_supcrs)*(MTOW*1e3); % Necessary fuel from ground  to supersonic cruise ending [kg]
W_supr_medium=(Wfuel_gsupclm+Wfuel_gsupcrs)/2;   %Medium necessary fuel from ground to starting climb and ended supersonic cruise [kg] 
%W_supr_medium=Wfuel_gsupcrs;
end

