%% TOOL
clear all
close all
clc

%% STATISTICAL ANALYSIS
disp('*******************************************************************')
disp('*******************************************************************')
disp('                      STATISTICAL ANALYSIS                         ')

[MTOW,NT,WS,C_HyLH2,ISP,SFC,Mach_utente,payload_utente,pax_utente] = StatisticalAnalysis();

%% MISSION PROFILE
disp('*******************************************************************')
disp('*******************************************************************')
disp('                        MISSION PROFILE                            ')
[fl2,fl3,fl4,fl5,fl6,fl7,fl8,flMA1,flMA2,fl10,t4,t6,t8,tMA2,choice_MA,t_tot] = MissionProfile();
%% CONVERGENCE LOOP -START
first=1; %First iteration

MTOW_start=MTOW; %FIRST VALUE OF MTOW [tons]
WS_start=WS; %FIRST VALUE OF WS [m2]
MTOW_pre=1000; %[tons]
eps=10;         %[tons]

TOP_in=0;  CL_to_in=0;  gamma_in=0;
A_in=0; B_in=0; Kvs_in=0; Kmaterial_in=0;
MES_in=0; MUTW_in=0; MUTL_in=0; MRT_in=0; MRTL_in=0;Lpax_in=0;
pmax_in=0; sigmaf_s_in=0;  E_s_in=0; kins_in=0; rhoins_in=0; Ts_in=0;
CLmax_in=0; Slnd_in=0; Sa_in=0; M_it_in=0; h_it_in=0;

cont=0;
WS_lnd=(MTOW*1e3)/WS; WS_it=(MTOW*1e3)/WS;

while abs(MTOW-MTOW_pre)>eps
    
    %if first==0
        S_lnd=(MTOW*1e3)/WS_lnd;   S_it=(MTOW*1e3)/WS_it;
        S=max(S_lnd,S_it);
        WS=S;
    %end
 %% AERODYNAMICS
 if first==1
     
     disp('*******************************************************************')
     disp('********************************************************************')
     disp('                         AERODYNAMICS                               ')
     [E_sub,E_sup,rhosub_crs,Vsub_crs,Msub,Msup,CL_sub, CL_sup,CD_sub,CD_sup,CD0_sub,CD0_sup,GainFactor,TA_OE,AR,e,d_int,d_ext,eff,c_SRM,...
         alfasub,alfasup,eta,sweep_w_d,sweep_w_r,l_ac,cr_w,b,cr_t,h_t,l_n,d_n,musub_crs,k,perc_l_f_sub,perc_l_w_sub,perc_l_t_sub,perc_l_n_sub,...
         p_f_sub,p_w_sub, p_t_sub,p_n_sub,p_f_sup,p_w_sup,p_t_sup,p_n_sup,x_c,t_c,p_md_sub,p_lp_sub,p_md_sup,p_lp_sup,S_c,Ewd,Q_w,Q_f,Q_t,Q_n] = Aerodynamics(NT,WS,...
         fl3,fl4);
     
 end
 
 if first==0
     
     [E_sub,E_sup,CL_sub, CL_sup,CD_sub,CD_sup,CD0_sub,CD0_sup,AR,e]=Aerodynamics_Loop(C_HyLH2,eff,S,c_SRM,Msub,Msup,alfasub,alfasup,eta,sweep_w_d,sweep_w_r,...
         l_ac,cr_w,b,d_ext,cr_t,h_t,l_n,d_n,GainFactor,rhosub_crs,Vsub_crs,musub_crs,k,perc_l_f_sub,perc_l_w_sub,perc_l_t_sub,perc_l_n_sub,p_f_sub,p_w_sub,...
         p_t_sub,p_n_sub,p_f_sup,p_w_sup,p_t_sup,p_n_sup,x_c,t_c,p_md_sub,p_lp_sub,p_md_sup,p_lp_sup,S_c,Ewd,Q_w,Q_f,Q_t,Q_n);
     
 end
 
%% FUEL WEIGTH

if first==1
    
    disp('********************************************************************')
    disp('********************************************************************')
    disp('                          FUEL WEIGHT                               ')
    [Wfuel,W_supr_medium,Vsup_crs,Vsup_clm,C_scale,choice_supclm,rsub_crs,SFCsub_crs,rsup_crs,SFCsup_crs,rsub_crs_d,SFCsub_crs_d,Vsub_crs_d,...
        r_crs_MA,SFC_crs_MA,V_crs_MA] = FuelWeight(C_HyLH2,MTOW,ISP,SFC,Mach_utente,fl4,fl5,fl6,fl7,fl8,flMA1,flMA2,Vsub_crs,E_sub,E_sup,t4,t6,t8,tMA2,...
        Msub,Msup,choice_MA);
    
end

if first==0
    
    [Wfuel,W_supr_medium]=FuelWeigth_Loop(choice_supclm,rsub_crs,SFCsub_crs,Vsub_crs,E_sub,E_sup,Msub,Msup,fl4,fl5,SFC,t4,rsup_crs,...
        SFCsup_crs,Vsup_crs,rsub_crs_d,SFCsub_crs_d,Vsub_crs_d,r_crs_MA,SFC_crs_MA,V_crs_MA,MTOW,choice_MA,C_HyLH2);

end
%% OEW
if first==1
    
    disp('********************************************************************')
    disp('********************************************************************')
    disp('                      OPERATIVE EMPTY WEIGHT                        ')
    
end

[OEW,A_out,B_out,Kvs_out,Kmaterial_out] = OperativeEmptyWeigth(MTOW,C_HyLH2,A_in,B_in,Kvs_in,Kmaterial_in,first);

A_in=A_out;
B_in=B_out;
Kvs_in=Kvs_out;
Kmaterial_in=Kmaterial_out;

%% WING LOADING VERIFICATION
%DA RIGUARDARE!!
%if first==1
    
%     disp('********************************************************************')
%     disp('********************************************************************')
%     disp('                      WING LOADING REQUIREMENTS                     ')
%     [WS_lnd,WS_lnd_sup,WS_it,WS_it_sup,rho_ref,W_supphases] = WS_RequirementVerification(fl10,CL_sub,CL_sup,fl4,fl6,W_supr_medium,payload_utente,OEW,MTOW);
%     
%end

% if first==0
%     
%     %WEIGTH
%     W_supphases=payload_utente+OEW+W_supr_medium; %[kg]
%     
% end
% DA VERIFICARE SE I PAREMETRI CHE VARIANO ALLA FINE SI DISCOSTANO TROOPO
% DAI VALORI INIZIALI . SE è COSI QUESTA AFSE DEVE ESERE INSERITA NEL LOOP

%PROVA DENTRO IL LOOP
if first==1
    
    disp('********************************************************************')
    disp('********************************************************************')
    disp('                      WING LOADING REQUIREMENTS                     ') 
end

[WS_lnd,WS_it,rho_ref,W_supphases,CLmax_out,Slnd_out,Sa_out,M_it_out,h_it_out] ...
    = WS_RequirementVerification(fl10,CL_sub,CL_sup,fl4,fl5,fl6,W_supr_medium,payload_utente,OEW,MTOW,CLmax_in,...
    Slnd_in,Sa_in,M_it_in,h_it_in,first);
CLmax_in=CLmax_out;
Slnd_in=Slnd_out;
Sa_in=Sa_out;
M_it_in=M_it_out;
h_it_in=h_it_out;

%% THRUST TO WEIGTH RATIO REQUIREMENTS VERIFICATION
if first==1
    
    disp('********************************************************************')
    disp('********************************************************************')
    disp('                 THRUST TO WEIGTH RATIO REQUIREMENTS                ')
    
end

[TW_subcrs,TW_to,TW_clm,TW_ss,WS_av,TOP_out,CL_to_out,gamma_out,sigma_to,Cl_bestg,...
    sigma_subcrs,T,D,sigma_subclm] = TW_RequirementVerification(rhosub_crs,Vsub_crs,Vsup_crs,Vsup_clm,CD0_sub,CD0_sup,MTOW,WS,fl2,fl3,fl4,...
    fl5,fl6,CL_sub,GainFactor,TA_OE,Msub,Msup,AR,e,rho_ref,W_supphases,TOP_in,CL_to_in,gamma_in,first);

TOP_in=TOP_out;
CL_to_in=CL_to_out;
gamma_in=gamma_out;
%% TANK AND STRUCTURAL/INSULATION LAYERS SIZING
if C_HyLH2==2
    
    if first==1
        disp('********************************************************************')
        disp('********************************************************************')
        disp('           TANK AND STRUCTURAL/INSULATION LAYERS SIZING             ')
    end

    [t_ut,t_rt,t_ins_def,tlayer_def_ut,tlayer_def_rt,d_ext,Lpax_out,MES_out,MUTW_out,MUTL_out,MRT_out,MRTL_out,...
    L_aircraft,pmax_out,sigmaf_s_out,E_s_out,kins_out,rhoins_out,Ts_out,Lfa,Lcenter,Lreartb,L_tailcone,wt,ht,lt,dintreart,...
    Lreart,hcab,hwing,d_int_out,Vmissing,Vunderfloor,havtank,Lret,pp,SM_s,tlayer] = Tank_Layer_Sizing(d_int, d_ext,pax_utente,...
    Wfuel,Msup,fl5,fl6,t_tot,Lpax_in,MES_in,MUTW_in,MUTL_in,MRT_in,MRTL_in,pmax_in,sigmaf_s_in,E_s_in,kins_in,rhoins_in,Ts_in,...
    first);

Lpax_in=Lpax_out;
MES_in=MES_out;
MUTW_in=MUTW_out;
MUTL_in=MUTL_out;
MRT_in=MRT_out;
MRTL_in=MRTL_out;
l_ac=L_aircraft;
d_int=d_int_out;
pmax_in=pmax_out;
sigmaf_s_in=sigmaf_s_out;
E_s_in=E_s_out;
kins_in=kins_out;
rhoins_in=rhoins_out;
Ts_in=Ts_out;

end
%% CONVERGENCE LOOP -END
MTOW_pre=MTOW;
MTOW=(OEW+payload_utente+Wfuel)*1e-3; %[tons]

first=0;

cont=cont+1;
disp(['loop:',num2str(cont)])
end
%% T/W REQUIREMENTS SUPERSONIC
[TW_supcrs,TW_supclm,WS_av_sup,rhosup_crs,Cl_bestg_sup,D_sup] = TW_RequirementsVerification_Supersonic(fl4,fl5,fl6,Vsup_crs,CD0_sup,W_supphases,S,...
    Msup,Vsup_clm,gamma_in,AR,e,T);
%% OUTPUT CONVERGENCE LOOP
disp('------------------------------------------------------------------ ')
disp('              WING LOADING REQUIREMENT(SEA LEVEL):                 ')
disp(' ')
disp(['W/S landing:',num2str(WS_lnd),'kg/m2'])
disp(['W/S instantaneous turn:',num2str(WS_it),'kg/m2'])
disp(['W/S available:',num2str(WS_av),'kg/m2'])
% disp('              WING LOADING REQUIREMENT(SUPERSONIC):                 ')
% disp(' ')
% disp(['W/S landing:',num2str(WS_lnd_sup),'kg/m2'])
% disp(['W/S instantaneous turn:',num2str(WS_it_sup),'kg/m2'])

disp('------------------------------------------------------------------ ')
disp('          THRUST TO WEIGHT RATIO REQUIREMENTS (SEA LEVEL):         ')
disp(' ')
disp(['T/W cruise :',num2str(TW_subcrs)])
disp(['T/W take off:',num2str(TW_to)])
disp(['T/W second segment:',num2str(TW_ss)])
disp(['T/W climb:',num2str(TW_clm)])
disp(' ')
disp('          THRUST TO WEIGHT RATIO REQUIREMENTS (SUPERSONIC):         ')
disp(' ')
disp(['T/W cruise :',num2str(TW_supcrs)])
disp(['T/W climb:',num2str(TW_supclm)])

disp('------------------------------------------------------------------ ')
disp('                    WEIGHTS AND SURFACE OUTPUT:                    ')
disp(' ')
disp(['Wing surface:',num2str(S),' m2'])
disp(['MTOW:',num2str(MTOW),'tons'])
disp(['Fuel weight:',num2str(Wfuel),'kg'])
disp(['OEW:',num2str(OEW),'kg'])

disp('------------------------------------------------------------------ ')
disp('                          AERODYNAMICS OUTPUT:                     ')
disp(' ')
disp('1.SUBSONIC')
disp(['CL:',num2str(CL_sub)])
disp(['CD:',num2str(CD_sub)])
disp(['E:',num2str(E_sub)])
disp(' ')
disp('2.SUPERSONIC')
disp(['CL:',num2str(CL_sup)])
disp(['CD:',num2str(CD_sup)])  
disp(['E:',num2str(E_sup)])

disp('------------------------------------------------------------------ ')
disp('                          GEOMETRIC OUTPUT:                     ')
disp(' ')
disp(['Fuselage External diameter:',num2str(d_ext)])
disp(['Fuselage Internal diameter:',num2str(d_int)])

if C_HyLH2==2
    
    disp(' ')
    disp(['Length of aircraft front part (AVIONIC BAY + COCKPIT) :',num2str(Lfa)])
    disp(['Length of center part of aircraft (PASSENGERS COMPARTMENT + REAR TANK BAY) :',num2str(Lcenter)])
    disp(['Length of PASSENGERS COMPARTMENT:',num2str(Lpax_in)])
    disp(['Length of REAR TANK BAY:',num2str(Lreartb)])
    disp(['Length of TAILCONE :',num2str(L_tailcone)])
    disp(['Length of AIRCRAFT :',num2str(L_aircraft)])
    disp(' ')
    disp('Sizes of UNDERFLOOR TANK')
    disp(['Width:',num2str(wt)])
    disp(['Heigth:',num2str(ht)])
    disp(['Length:',num2str(lt)])
    disp(' ')
    disp('Sizes of REAR TANK')
    disp(['Width:',num2str(dintreart)])
    disp(['Heigth:',num2str(dintreart)])
    disp(['Length:',num2str(Lreart)])
    
    disp('------------------------------------------------------------------ ')
    disp('                          STRUCTURAL AND INSULATION LAYER:                     ')
    disp(' ')
    disp('UNDERFLOOR TANK')
    disp(['Structural materiale thickness:',num2str(t_ut)])
    disp(['Insulation materiale thickness:',num2str(t_ins_def)])
    disp(['Total layer thickness:',num2str(tlayer_def_ut)])
    disp(' ')
    disp('REAR TANK')
    disp(['Structural materiale thickness:',num2str(t_rt)])
    disp(['Insulation materiale thickness:',num2str(t_ins_def)])
    disp(['Total layer thickness:',num2str(tlayer_def_rt)])

    %% AIRCRAFT CENTRE OF GRAVITY
    disp('********************************************************************')
    disp('********************************************************************')
    disp('                    AIRCRAFT CENTER OF GRAVITY                      ')
    [Xcg,Xcg_ZF] = CG(L_aircraft,Lfa,Lreartb,Lpax_in,OEW,payload_utente,Vmissing,Vunderfloor);
    %% POST PROCESSING
    [x1,x2] = PostProcessing(d_ext,d_int,havtank,hwing,wt,ht,tlayer_def_ut,dintreart,tlayer_def_rt,Lfa,Lpax_in,Lcenter,...
    Lreart,MRTL_in,L_tailcone,Lret,MUTL_in,pp,E_s_in,sigmaf_s_in,SM_s,t_ut,t_rt,fl6,kins_in,t_tot,rhoins_in,tlayer,t_ins_def,...
    Xcg,Xcg_ZF);

end
%% MATCHING CHART
    
     [DP_x,DP_y] = MatchingChart(WS_lnd,WS_it,TW_ss,TOP_in, CL_to_in,sigma_to,rhosub_crs,rhosup_crs,Vsub_crs,Vsup_crs,...
        CD0_sub,CD0_sup,Cl_bestg,Cl_bestg_sup,sigma_subcrs,T,D,sigma_subclm, D_sup,S,...
        W_supphases,WS_av,WS_av_sup);