function [DP_x,DP_y] = MatchingChart(WS_lnd,WS_it,TW_ss,TOP_in, CL_to_in,sigma_to,rhosub_crs,rhosup_crs,Vsub_crs,Vsup_crs,...
        CD0_sub,CD0_sup,Cl_bestg,Cl_bestg_sup,sigma_subcrs,T,D,sigma_subclm, D_sup,S,...
        W_supphases,WS_av,WS_av_sup)

%REQUIREMENTS' CURVES: REFERRED TO SEA LEVEL

%% AXIS
TW_v=linspace(0,1,100000);
WS_v=linspace(0,900,100000);

%% SUBSONIC MATCHING CHART
figure (121)
hold on
%% WING LOADING AVAILABLE
WS_av_v=zeros(1,length(TW_v));
WS_av_v(1,1:end)=WS_av;       %SEA LEVEL

plot(WS_av_v,TW_v,'--r','LineWidth',1.5)
%% LANDING
WS_lnd_v=zeros(1,length(TW_v));
WS_lnd_v(1,1:end)=WS_lnd;       %SEA LEVEL

plot(WS_lnd_v,TW_v,'Color',[0 0.4470 0.7410],'LineWidth',2)

%% INSTANTANEOUS TURN
WS_it_v=zeros(1,length(TW_v));
WS_it_v(1,1:end)=WS_it;         %SEA LEVEL

plot(WS_it_v,TW_v,'Color',[0.3010 0.7450 0.9330],'LineWidth',2)

%% SECOND SEGMENT
TW_ss_v=zeros(1,length(WS_v));
TW_ss_v(1,1:end)=TW_ss;         %SEA LEVEL

plot(WS_v,TW_ss_v,'Color',[0.4940 0.1840 0.5560]','LineWidth',2)
%% TAKE OFF
TOP=TOP_in;
CL_to=CL_to_in;
TW_to_v=WS_v./(TOP*sigma_to*CL_to); %SEA LEVEL
TW_to=WS_av/(TOP*sigma_to*CL_to); %SEA LEVEL
 
 plot(WS_v,TW_to_v,'Color',[0.4660 0.6740 0.1880],'LineWidth',2)

 %% CRUISE SUBSONIC
 TW_crs_v=((0.5*rhosub_crs*Vsub_crs^2*CD0_sub)./WS_v)*sigma_subcrs;
 TW_crs=((0.5*rhosub_crs*Vsub_crs^2*CD0_sub)/WS_av)*sigma_subcrs;
 plot(WS_v,TW_crs_v,'Color',[0.9290 0.6940 0.1250],'LineWidth',2)
 
 %% CLIMB SUBSONIC
 TW_clm_v=2*Cl_bestg+((T-D)./(9.81*S*WS_v))*sigma_subclm;
 TW_clm=2*Cl_bestg+((T-D)/(9.81*S*WS_av))*sigma_subclm;
 
 plot(WS_v,TW_clm_v,'Color',[0.6350 0.0780 0.1840],'LineWidth',2)
 
 %% DESIGN POINT
 TW_v=[TW_ss,TW_to,TW_crs,TW_clm];
 DP_y=max(TW_v);
 DP_x=WS_av;
 
 plot(DP_x,DP_y,'*r','LineWidth',2)
 
  %% 
 legend('Wing Loading Available','Landing','Instantaneous Turn','Second Segment',...
     'Take Off','Cruise','Climb','Location','best')
 
 ylim([0 1])
 ylabel('T/W')
 xlabel('W/S [kg/m^2]')
 
 title('Subsonic Matching chart')
 
 grid minor
 
 %% SUPERSONIC MATCHING CHART
 
 %% AXIS
TW_v=linspace(0,1,100);
WS_v=linspace(0,600,100);

 figure (122)
hold on

% %% LANDING
% WS_lnd_v=zeros(1,length(TW_v));
% WS_lnd_v(1,1:end)=WS_lnd_sup;       
%  
% plot(WS_lnd_v,TW_v,'Color',[0 0.4470 0.7410],'LineWidth',2)
% %% INSTANTANEOUS TURN
% WS_it_v=zeros(1,length(TW_v));
% WS_it_v(1,1:end)=WS_it_sup;         %SEA LEVEL
% 
% plot(WS_it_v,TW_v,'Color',[0.3010 0.7450 0.9330],'LineWidth',2)

%% CRUISE
 TW_crs_v=(0.5*rhosup_crs*Vsup_crs^2*CD0_sup)./WS_v;
 TW_crs=(0.5*rhosup_crs*Vsup_crs^2*CD0_sup)./WS_av_sup;

 plot(WS_v,TW_crs_v,'Color',[0.9290 0.6940 0.1250],'LineWidth',2)
 
 %% CLIMB -SUBSONIC
 TW_clm_v=(2*Cl_bestg_sup+(T-D_sup)/(9.81*S)./WS_v);
 TW_clm=(2*Cl_bestg_sup+(T-D_sup)/(9.81*S)./WS_av_sup);
 
 plot(WS_v,TW_clm_v,'Color',[0.6350 0.0780 0.1840],'LineWidth',2)
 %% WING LOADING AVAILABLE
WS_av_v=zeros(1,length(TW_v));
WS_av_v(1,1:end)=WS_av_sup;       %SEA LEVEL

plot(WS_av_v,TW_v,'--r','LineWidth',1.5)
 %% DESIGN POINT
 DP_y=max(TW_crs,TW_clm);
 DP_x=WS_av_sup;
 
 plot(DP_x,DP_y,'*r','LineWidth',2)
 %% 
 legend('Cruise','Climb','Wing Loading Available','Design Point','Location','best')
 ylim([0 1])
 ylabel('T/W')
 xlabel('W/S [kg/m^2]')
 
 title('Supersonic Matching chart')
 
 grid minor
 
end

