function [MAC_w,MAC_t,sweep_t_d, sweep_t_r] = MeanAerodynamicChord(b,d_ext,cr_w,h_t,cr_t)
%The MAC is estimated through two step:
%1. Hypothesis: MAC location is at one third of half-span for wing and
%height for tail
%2. Scale value through root chord-half-span or height ratio
%
%In this functioin is also estimated the sweep angle of tail in a very
%semplyfied method


hy=1/3;

%Wing
loc=hy*(b/2-d_ext/2);           %location of MAC
MAC_w=(cr_w*loc)/(b/2-d_ext/2); % 'scale' procedure



%Tail
loc=hy*h_t;           %location of MAC
MAC_t=(cr_t*loc)/h_t; % 'scale' procedure

angle=atan(h_t/cr_t);
sweep_t_r=pi/2-angle;        %[rad]
sweep_t_d=sweep_t_r*180/pi;  %[°]

end

