function [fl2,fl3,fl4,fl5,fl6,fl7,fl8,flMA1,flMA2,fl10,t4,t6,t8,tMA2,choice_MA,t_tot] = MissionProfile()
% DESCRIPTION: BUILDING MISSION PROFILE

%OUTPUT: ALTITUDE AND DURATION OF EACH PHASES
%        fl2 (airport departure altitude)-->TW_RequirementVerification
%        fl3(subsonic climb end/ cruise start)-->Fuel Weight , Aerodynamics
%        fl4 (subsonic cruise end/ supersonic climb start) -->Fuel Weight , Aerodynamics, WS_RequirementVerification
%        fl5 (supersonic climb end/cruise start)-->Fuel Weight,Tank_Layer_Sizing.m
%        fl6 (supersonic cruise end) --> WS_RequirementVerification, FuelWeight,Tank_Layer_Sizing.m
%        fl7,fl8  (subsonic cruise descent) --> Fuel Weight
%        flMA1,flMA2  (subsonic cruise Missed Approach) --> Fuel Weight
%        fl10 (Landing, altitude destination airport) --> WS_RequirementVerification
%         t4 (subsonic cruise duration)--> Fuel Weight
%         t6 (supersonic cruise duration)--> Fuel Weight
%         t8 (subsonic cruise descent duration)--> Fuel Weight
%         tMA2 (subsonic cruise Missed Approach duration)--> Fuel Weight
%        choice_MA (choice implementation MA) --> Fuel Weigth
%        t_tot (total mission duration)-->Tank_Layer_Sizing.m
%% INITIALIZZAZION OF VARIABLES
tpre=0;     %Previously duration
flpre=0;    %Previously altitude
numphase=1; %Number of phase
t_tot=0;    %Total Duration of mission

%% WARM UP- ON GROUND

disp(['PHASE ',num2str(numphase),': Warm up'])
t1=10;
disp(['Duration [min]: ',num2str(t1)])

% disp('Duration [min]:') 
% t1=input('');

fl1=0;
disp(['Altitude of airport [m]:',num2str(fl1)])
% disp('Altitude of airport [m]:')
% fl1=input('');

numphase=numphase+1;
t_tot=t_tot+t1;

disp('-------------------------------------------------------------------------------------------')

figure(21)
x=tpre:t1;
%Altitude=((x-tpre)/(t1-tpre))*(fl1-flpre)+fl1 --> RETTA PASSANTE PER DUE PUNTI
plot(x,((x-tpre)/(t1-tpre))*(fl1-flpre)+flpre,'Linewidth',2)
grid minor
xlabel('Time [min]')
ylabel('Altitude [m]')
legend('Warm up')

tpre=tpre+t1; flpre=fl1;

%% TAKE OFF - ON GROUND

disp(['PHASE ',num2str(numphase),': Take off'])
t2=10;
disp(['Duration [min]: ',num2str(t2)])

% disp('Duration [min]: ')
% t2=input('');

fl2=fl1;             %The altitude of take off is the same of the warm up phase that is the airport's altitude
%hlo=fl2;

numphase=numphase+1;
t_tot=t_tot+t2;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t2;
%Altitude=((x-tpre)/(t1-tpre))*(fl1-flpre)+fl1 --> RETTA PASSANTE PER DUE PUNTI
plot(x,((x-tpre)./t2).*(fl2-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off')

tpre=tpre+t2; flpre=fl2;

%% SUBSONIC CLIMB - IN FLIGHT

disp(['PHASE ',num2str(numphase),': Subsonic climb'])

t3=15;
disp(['Duration [min]: ',num2str(t3)])

%     disp('Duration [min]: ')
%     t3=input('');

fl3=4572; %FL150
disp(['Altitude [m]: ',num2str(fl3)])
%     disp('Altitude [m]:')
%     fl3=input('');

t_tot=t_tot+t3;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t3;
%Altitude=((x-tpre)/(t1-tpre))*(fl1-flpre)+fl1 --> RETTA PASSANTE PER DUE PUNTI
plot(x,((x-tpre)/(t3))*(fl3-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb')

tpre=tpre+t3; flpre=fl3;

%% SUBSONIC CRUISE - IN FLIGHT
    
disp(['PHASE ',num2str(numphase),': Subsonic cruise'])
t4=30;
disp(['Duration [min]: ',num2str(t4)])

% disp('Duration [min]:')
% t4=input('');

fl4=7315; %FL240
disp(['Altitude [m]: ',num2str(fl4)])

% disp('Altitude [m]: ')
% fl4=input('');

numphase=numphase+1;
t_tot=t_tot+t4;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t4;
plot(x,((x-tpre)/(t4))*(fl4-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise')

tpre=tpre+t4; flpre=fl4;

%% SUPERSONIC CLIMB - IN FLIGHT 

disp(['PHASE ',num2str(numphase),': Supersonic climb'])
t5=25;
disp(['Duration [min]: ',num2str(t5)])

%     disp('Duration [min]: ')
%     t5=input('');

fl5=18288; %FL600
disp(['Altitude [m]: ',num2str(fl5)])

%     disp('Altitude [m]: ')
%     fl5=input('');

t_tot=t_tot+t5;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t5;
%Altitude=((x-tpre)/(t1-tpre))*(fl1-flpre)+fl1 --> RETTA PASSANTE PER DUE PUNTI
plot(x,((x-tpre)/(t5))*(fl5-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb')

tpre=tpre+t5; flpre=fl5;

%% SUPERSONIC CRUISE - IN FLIGHT

disp(['PHASE ',num2str(numphase),': Supersonic cruise'])
t6=150;
disp(['Duration [min]: ',num2str(t6)])

% disp('Duration [min]: ')
% t6=input('');

fl6=18288; %FL600
disp(['Altitude [m]: ',num2str(fl6)])

% disp('Altitude [m]: ')
% fl6=input('');

t_tot=t_tot+t6;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')

hold on
x=tpre:tpre+t6;
plot(x,((x-tpre)/(t6))*(fl6-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise')

tpre=tpre+t6; flpre=fl6;
      
%% SUPERSONIC DESCENT - IN FLIGHT

disp(['PHASE ',num2str(numphase),': Supersonic descent'])
t7=25;
disp(['Duration [min]: ',num2str(t7)])

%     disp('Duration [min]: ')
%     t7=input('');

fl7=7315; %FL240
disp(['Altitude [m]: ',num2str(fl7)])

%     disp('Altitude [m]: ')
%     fl7=input('');

t_tot=t_tot+t7;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t7;
plot(x,((x-tpre)./(t7)).*(fl7-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent')

tpre=tpre+t7; flpre=fl7;

%% SUBSONIC CRUISE (DESCENT) - IN FLIGHT
    
disp(['PHASE ',num2str(numphase),': Subsonic cruise (descent)'])
t8=30;
disp(['Duration [min]: ',num2str(t8)])

% disp('Duration [min]: ')
% t8=input('');

fl8=3000; %FL100
disp(['Altitude [m]: ',num2str(fl8)])

% disp('Altitude [m]: ')
% fl8=input('');

t_tot=t_tot+t8;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t8;
plot(x,((x-tpre)/(t8))*(fl8-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent')

tpre=tpre+t8; flpre=fl8;

%% SUBSONIC DESCENT - IN FLIGHT

disp(['PHASE ',num2str(numphase),': Subsonic descent'])
t9=15;
disp(['Duration [min]: ',num2str(t9)])

%     disp('Duration [min]: ')
%     t9=input('');

fl9=1524; %FL50- 5000 ft
disp(['Attitude [m]: ',num2str(fl9)])

%     disp('Attitude [m]: ')
%     fl9=input('');

t_tot=t_tot+t9;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t9;
plot(x,((x-tpre)./(t9)).*(fl9-flpre)+flpre,'Linewidth',2)
legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent')

tpre=tpre+t9; flpre=fl9;

%% CHOICE TO IMPLEMENT MISSED APPROACH OR NOT.

disp('Do you introduce a missed approach in the mission profile?')
disp('1. YES')
disp('2. NO')
choice_MA=input('');

if choice_MA==1 %YES
    
    %% CLIMB MA 
    disp(' ')
    disp(['PHASE ',num2str(numphase),': Climb missed approach'])
    tMA1=15;
    disp(['Duration [min]',num2str(tMA1)])
    
    %     disp('Duration [min]')
    %     tMA1=input('');
    
    flMA1=3000; %FL100
    disp(['Altitude [m]: ',num2str(flMA1)])
    
    %     disp('Altitude [m]: ')
    %     flMA1=input('');
    
    t_tot=t_tot+tMA1;
    numphase=numphase+1;
    
    disp('-------------------------------------------------------------------------------------------')
    

    hold on
    x=tpre:tpre+tMA1;
    plot(x,((x-tpre)/(tMA1))*(flMA1-flpre)+flpre,'Linewidth',2)
    legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','MA: Climb')
    tpre=tpre+tMA1; flpre=flMA1;
    
    %% CRUISE MA
    disp(' ')
    disp(['PHASE ',num2str(numphase),': Cruise missed approach'])
    tMA2=20;
    disp(['Duration [min]',num2str(tMA2)])
    
%     disp('Duration [min]')
%     tMA2=input('');

    flMA2=3000; %FL100
    disp(['Altitude [m]: ',num2str(flMA2)])
    
%     disp('Altitude [m]: ')
%     flMA2=input('');

    t_tot=t_tot+tMA2;
    numphase=numphase+1;
    
    disp('-------------------------------------------------------------------------------------------')

    hold on
    x=tpre:tpre+tMA2;
    plot(x,((x-tpre)/(tMA2))*(flMA2-flpre)+flpre,'Linewidth',2)
    legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','MA: Climb','MA: Cruise')
    tpre=tpre+tMA2; flpre=flMA2;
    
    %% DESCENT MA
    disp(' ')
    disp(['PHASE ',num2str(numphase),': Descent missed approach'])
    tMA3=15;
    disp(['Duration [min]',num2str(tMA3)])
    
%     disp('Duration [min]: ')
%     tMA3=input('');

    flMA3=1524; %FL50
    disp(['Altitude [m]: ',num2str(flMA3)])
    
%     disp('Altitude [m]: ')
%     flMA3=input('');

    t_tot=t_tot+tMA3;
    numphase=numphase+1;
    
    disp('-------------------------------------------------------------------------------------------')
    
    hold on
    x=tpre:tpre+tMA3;
    plot(x,((x-tpre)/(tMA3))*(flMA3-flpre)+flpre,'Linewidth',2)
    legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','MA: Climb','MA: Cruise','MA: Descent')
    tpre=tpre+tMA3; flpre=flMA3;
    
end

% if choice==2
%     
%     r_subcrs_MA=0;
%     SFC_subcrs_MA=0;
%     V_subcrs_MA=0;
%     
% end

%disp('-------------------------------------------------------------------------------------------')

%% LANDING - IN FLIGHT

disp(['PHASE ', num2str(numphase),': Landing'])
t10=10;
disp(['Duration [min]: ',num2str(t10)])

% disp('Duration [min]: ')
% t10=input('');

fl10=0;
disp(['Altitude of destination airport [m]:',num2str(fl10)])

% disp('Altitude of destination airport [m]:')
%     fl10=input('');
%     hlnd=fl10; 


t_tot=t_tot+t10;
numphase=numphase+1;

disp('-------------------------------------------------------------------------------------------')

hold on
x=tpre:tpre+t10;
plot(x,((x-tpre)/(t10))*(fl10-flpre)+flpre,'Linewidth',2)

     if choice_MA==1
         legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','MA: Climb','MA: Cruise','MA: Descent','Landing')
     else
         legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','Landing')
     end
     
tpre=tpre+t10; flpre=fl10;

 %% TAXI OUT - ON GROUND

disp(['PHASE ', num2str(numphase),': Taxi out'])
t11=10;
disp(['Duration [min]: ',num2str(t11)])

% disp('Duration [min]: ')
% t11=input('');

fl=fl10;

t_tot=t_tot+t11;

disp('-------------------------------------------------------------------------------------------')


hold on
x=tpre:tpre+t11;
plot(x,((x-tpre)/(t11))*(fl-flpre)+flpre,'Linewidth',2)
% tpre=tpre+t11; flpre=fl;
    
    if choice_MA==1
         legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','MA: Climb','MA: Cruise','MA: Descent','Landing','Taxi out')
     else
         legend('Warm up','Take off' , 'Subsonic climb','Subsonic cruise','Supersonic climb','Supersonic cruise','Supersonic descent','Subsonc cruise', 'Subsonic descent','Landing','Taxi out')
    end
%%   
disp('-------------------------------------------------------------------------------------------')
disp(['TOtal Duration of Mission:',num2str(t_tot/60),' hours'])

end

