function [Sratio, Sexp] = SurfaceRatio_Loop(b,cr_w,d_ext,S,c_SRM)
%Three methods to estimate the surface ratio:

%1-Dummy approach: The wing is considered such as a triangle with (b/2-d/2)
%as a base and root chord for height
%Sexp: surface exposed of half wing , one part (or buttom or up)
%Scov: wing surface 'covered' by the fuselage , assuming as a rectangle
%with (d x cr) dimensions
%Sref: Reference surface , the intair surface: two times the exposed plus
%the covered 
% Sratio=Sexposed,total/Sref=(Sref-Scov)/Sref=1-Scov/Sref

%2-Concorde related approach
%Sref is assuming by statistical values relating to Concorde
%S cov is the same rectangle of previous method

%3-Statistical analysis approach
%Sref is assuming by statistical values in output for this case of study
%S cov is the same rectangle of previous method

%1.Dummy approach
if c_SRM==1
    
    Sexp=((b/2-d_ext/2)*cr_w)/2; %[m2]
    %Scov=d*cr; %[m2]
    Sratio=Sexp*2/S;
    
end

%2.Concorde related approach
if c_SRM==2
    
    Scov=d_ext*cr_w; %[m2]
    Sratio=1-Scov/S;
    Sexp=(Sratio*S)/2; %one side of one half-wing
   
end


%3.Statistical analysis approach'
if c_SRM==3
    
    Scov=d_ext*cr_w; %[m2]
    Sratio=1-Scov/S;
    Sexp=(Sratio*S)/2; %one side of one half-wing
    
end
end

