function [TW_subcrs,TW_to,TW_clm,TW_ss,WS_av,TOP_out,CL_to_out,gamma_out,sigma_to,Cl_bestg,...
    sigma_subcrs,T,D,sigma_subclm] = TW_RequirementVerification(rhosub_crs,Vsub_crs,Vsup_crs,Vsup_clm,CD0_sub,CD0_sup,MTOW,WS,fl2,fl3,fl4,...
    fl5,fl6,CL_sub,GainFactor,TA_OE,Msub,Msup,AR,e,rho_ref,W_supphases,TOP_in,CL_to_in,gamma_in,first)
%REQUIREMENT'S COMPUTATION [T/W]: CRUISE (SUB AND SUPER SONIC), TAKE OFF, SECOND
%SEGMENT AND CLIMB
%% OVERALL VARIABLES
WS_av=(MTOW*1e3)/WS; %[kg/m2]
rhosl=1.225; %[kg/m3]
%% SUBSONIC CRUISE
if first==1
    
    disp('                    -SUBSONIC CRUISE REQUIREMENT- ')

end

sigma_subcrs=rhosl/rhosub_crs;
TW_subcrs=((0.5*rhosub_crs*Vsub_crs^2*CD0_sub)/WS_av)*sigma_subcrs;

if first==1
    disp('OUTPUT')
    disp(['Density: ',num2str(rhosub_crs),' kg/m3'])
    disp(['Density Ratio: ',num2str(sigma_subcrs)])
    disp(['T/W: ',num2str(TW_subcrs)])
end


%% SUPERSONIC CRUISE
% if first==1
%     disp('                     -SUPERSONIC CRUISE REQUIREMENT- ')
% end
% 
% 
% %DENSITY supersonic cruise
% h_v=fl5:1:fl6;  
% rhom=0; contRHO=0;
% 
% for i=1:length(h_v)
%     h=h_v(i);
%     
%     rho=(0.363*exp(-(h-11000)/6341.33));       %[kg/m3] International Standard Atmosphere - Stratosphere
%     rhom=rhom+rho;
%     contRHO=contRHO+1;
% end
% rhosup_crs=rhom/contRHO;  %medium density
% 
% sigma_supcrs=rho_ref/rhosup_crs;
% %(W_supphases/WS)=min(WS_lnd_sup,WS_it_sup);
% TW_supcrs=((0.5*rhosup_crs*Vsup_crs^2*CD0_sup)/min(WS_lnd_sup,WS_it_sup))*sigma_supcrs;
% 
% if first==1
%     disp('OUTPUT')
%     disp(['Density: ',num2str(rhosup_crs),' kg/m3'])
%     disp(['Density Ratio: ',num2str(sigma_supcrs)])
%     disp(['T/W: ',num2str(TW_supcrs)])
% end

%% TAKE OFF

if first==1
    
disp(' ')
disp('                       -TAKE OFF REQUIREMENT- ')
disp(' ')
%% RUNWAY LENGTH AND TOP
runway_to=input('Insert a value of take off runway lenght [m]:');
disp(['Take off runway lenght [ft]',num2str(runway_to*3.28084)])
disp(' ')
disp('In FIGURE 71 typical values of TOP are showed.')
figure (71)
TOP_im=imread('TOP.png');
imshow(TOP_im)

TOP=input('Insert a value of TOP (Take Off Parameter) [lb/ft2]:');               %[lb/ft2]
TOP=TOP*(0.453592/0.092903); %[kg/m2]
TOP_out=TOP;

close (figure(71))
else
   TOP=TOP_in;
   TOP_out=TOP_in;
end
%% DENSITY

if fl2==0               %AIRPORT AT SEA LEVEL 
    rho_to=1.225;                         
    sigma_to=rho_to/1.225; 
else
    rho_to=1.226*(1-0.0000226*fl2)^4.256; %[kg/m3] International Standard Atmosphere - Troposphere
    sigma_to=rho_to/1.225; 
end

%% CL TAKE OFF
if first==1

disp(' ')
disp('Do you want insert a value of CL at take off?')
disp('1. YES         2.NO')
choice_CLto=input('');

if choice_CLto==1 
    CL_to=input('CL,to: ');
    CL_to_out=CL_to;
end

if choice_CLto==2
    disp('CL is computed as: 1.4*CL,subsonic')
    CL_to=1.4*CL_sub;
    disp(['CL,to :',num2str(CL_to)])
    CL_to_out=CL_to;
end

else
   CL_to=CL_to_in;
   CL_to_out=CL_to_in;
end


TW_to=WS_av/(TOP*sigma_to*CL_to);  %SEA LEVEL 

if first==1
    disp(' ')
    disp('OUTPUT')
    disp(['Density: ',num2str(rho_to),' kg/m3'])
    disp(['Density Ratio: ',num2str(sigma_to)])
    disp(['T/W: ',num2str(TW_to)])
end

%% CLIMB - SUBSONIC

if first==1

disp(' ')
disp('                    -CLIMB & SECOND SEGMENT REQUIREMENTS- ')
disp(' ')
gamma=input('Insert a value of climb angle [°]:');
disp('!!! ATTENTION: the value of climb angle is valid also for supersonic climb.!!!')
gamma=(gamma*pi)/180; %[rad]
gamma_out=gamma;

else
    gamma=gamma_in;
    gamma_out=gamma_in;
end

%% THRUST IN CLIMB
ne=round(GainFactor);        %number of operative engine
T=ne*TA_OE*1e3;              %[N] 

%% SPEED AND DENSITY
hclm_v=fl2:fl3;
dt=(Msub-0)/length(hclm_v);
Mclm_v=0:dt:Msub;
Vm=0;
rhom=0;
contV=0;
contRHO=0;

for  i=1:min(length(hclm_v),length(Mclm_v))

    h=hclm_v(i);
    M=Mclm_v(i);

    [V] = Speed(h,M);
    Vm=V+Vm;
    contV=contV+1;

    rho_clm=(1.226*(1-0.0000226*h)^4.256); %[kg/m3] International Standard Atmosphere - Troposphere
    rhom=rhom+rho_clm;
    contRHO=contRHO+1;

end

Vsub_clm=Vm/contV;      %medium speed 
rho_subclm=rhom/contRHO;  %medium density
sigma_subclm=rhosl/rho_subclm;
%% DRAG AND CL CLIMB
%CDto=T/(0.5*rho_clm*V_clm^2*S)-CLto*tan(gamma);
CD_to=(T-(MTOW*1e3*9.81*sin(gamma)))/(0.5*rho_subclm*Vsub_clm^2*WS);  %Equilibrium equation in climb, steady condition [acceleration negligeble]
D=0.5*rho_subclm*Vsub_clm^2*WS*CD_to;  %[N]

Cl_bestg=sqrt(CD0_sub/pi*AR*e);

TW_clm=((T-D)/(9.81*WS*WS_av))+2*Cl_bestg; 
TW_clm=TW_clm*sigma_subclm;

if first==1
    disp(' ')
    disp('OUTPUT SUBSONIC CLIMB')
    disp(['Speed: ',num2str(Vsub_clm),' m/s'])
    disp(['Density: ',num2str(rho_subclm),' kg/m3'])
    disp(['Density Ratio: ',num2str(sigma_subclm)])
    disp(['CD,to: ',num2str(CD_to)])
    disp(['CL,bestg: ',num2str(Cl_bestg)])
    disp(['T/W: ',num2str(TW_clm)])
end


%% SECOND SEGMENT

TW_ss=ne/(ne-1)*CD_to/CL_to+sin(gamma);
TW_ss=TW_ss*sigma_to;                    %SEA LEVEL

if first==1
    disp(' ')
    disp('OUTPUT SECOND SEGMENT')
    disp('Density and Density Ratio is the same of TAKE OFF')
    disp(['T/W: ',num2str(TW_ss)])
end


%% CLIMB - SUPERSONIC
%DENSITY supersonic climb
% h_v=fl4:1:fl5;  
% rhom=0; contRHO=0;
% Vm=0; contV=0;
% M=Msup;
% 
% for i=1:length(h_v)
%     if h<=11000
%         rho=(1.226*(1-0.0000226*h)^4.256); %[kg/m3] International Standard Atmosphere - Troposphere
%         rhom=rhom+rho;
%         contRHO=contRHO+1;
%         
%         if Vsup_clm==0  % CONSTANT VALUE OF WEIGTH RATIO
%             [V]=Speed(h,M);
%             Vm=V+Vm;
%             contV=contV+1;
%         end
%         
%     end
%     
%     if h>11000
%         rho=(0.363*exp(-(h-11000)/6341.33));       %[kg/m3] International Standard Atmosphere - Stratosphere
%         rhom=rhom+rho;
%         contRHO=contRHO+1;
%         
%         if Vsup_clm==0 % CONSTANT VALUE OF WEIGTH RATIO
%             [V]=Speed(h,M);
%             Vm=V+Vm;
%             contV=contV+1;
%         end
%         
%     end
% end
% rhosup_clm=rhom/contRHO;  %medium density
% 
% if Vsup_clm==0   % CONSTANT VALUE OF WEIGTH RATIO
%     Vsup_clm=Vm/contV;
% end
% %W_supphase modifcato con (min(WS_lnd_sup,WS_it_sup)*S
% 
% CD_to_sup=(T-((min(WS_lnd_sup,WS_it_sup)*WS*9.81*sin(gamma))))/(0.5*rhosup_clm*Vsup_clm^2*WS);  %Equilibrium equation in climb, steady condition [acceleration negligeble]
% D_sup=0.5*rhosup_clm*Vsup_clm^2*WS*CD_to_sup;  %[N]
% 
% Cl_bestg_sup=sqrt(CD0_sup/pi*AR*e);
% 
% TW_supclm=((T-D_sup)/((min(WS_lnd_sup,WS_it_sup)*WS)*9.81))+2*Cl_bestg_sup;
% 
% sigma_supclm=rho_ref/rhosup_clm;
% TW_supclm=TW_supclm*sigma_supclm;
% 
% if first==1
%     disp(' ')
%     disp('OUTPUT SUPERSONIC CLIMB')
%     disp(['Speed: ',num2str(Vsup_clm),' m/s'])
%     disp(['Density: ',num2str(rhosup_clm),' kg/m3'])
%     disp(['Density Ratio: ',num2str(sigma_supclm)])
%     disp(['CD,to: ',num2str(CD_to_sup)])
%     disp(['CL,bestg: ',num2str(Cl_bestg_sup)])
%     disp(['T/W: ',num2str(TW_supclm)])
% end

end

