function [TW_supcrs,TW_supclm,WS_av_sup,rhosup_crs,Cl_bestg_sup,D_sup] = TW_RequirementsVerification_Supersonic(fl4,fl5,fl6,Vsup_crs,CD0_sup,W_supphases,S,...
    Msup,Vsup_clm,gamma_in,AR,e,T)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
%% SUPERSONIC CRUISE

    %disp('                     -SUPERSONIC CRUISE REQUIREMENT- ')



%DENSITY supersonic cruise
h_v=fl5:1:fl6;  
rhom=0; contRHO=0;

for i=1:length(h_v)
    h=h_v(i);
    
    rho=(0.363*exp(-(h-11000)/6341.33));       %[kg/m3] International Standard Atmosphere - Stratosphere
    rhom=rhom+rho;
    contRHO=contRHO+1;
end
rhosup_crs=rhom/contRHO;  %medium density

%sigma_supcrs=rho_ref/rhosup_crs;
%(W_supphases/WS)=min(WS_lnd_sup,WS_it_sup);
TW_supcrs=((0.5*rhosup_crs*Vsup_crs^2*CD0_sup)/(W_supphases/S));%*sigma_supcrs;

% if first==1
%     disp('OUTPUT')
%     disp(['Density: ',num2str(rhosup_crs),' kg/m3'])
%     disp(['Density Ratio: ',num2str(sigma_supcrs)])
%     disp(['T/W: ',num2str(TW_supcrs)])
% end
%% CLIMB - SUPERSONIC
%DENSITY supersonic climb
h_v=fl4:1:fl5;  
rhom=0; contRHO=0;
Vm=0; contV=0;
M=Msup;

for i=1:length(h_v)
    if h<=11000
        rho=(1.226*(1-0.0000226*h)^4.256); %[kg/m3] International Standard Atmosphere - Troposphere
        rhom=rhom+rho;
        contRHO=contRHO+1;
        
        if Vsup_clm==0  % CONSTANT VALUE OF WEIGTH RATIO
            [V]=Speed(h,M);
            Vm=V+Vm;
            contV=contV+1;
        end
        
    end
    
    if h>11000
        rho=(0.363*exp(-(h-11000)/6341.33));       %[kg/m3] International Standard Atmosphere - Stratosphere
        rhom=rhom+rho;
        contRHO=contRHO+1;
        
        if Vsup_clm==0 % CONSTANT VALUE OF WEIGTH RATIO
            [V]=Speed(h,M);
            Vm=V+Vm;
            contV=contV+1;
        end
        
    end
end
rhosup_clm=rhom/contRHO;  %medium density

if Vsup_clm==0   % CONSTANT VALUE OF WEIGTH RATIO
    Vsup_clm=Vm/contV;
end
%W_supphase modifcato con (min(WS_lnd_sup,WS_it_sup)*S
gamma=gamma_in;
CD_to_sup=(T-((W_supphases/S)*S*9.81*sin(gamma)))/(0.5*rhosup_clm*Vsup_clm^2*S);  %Equilibrium equation in climb, steady condition [acceleration negligeble]
D_sup=0.5*rhosup_clm*Vsup_clm^2*S*CD_to_sup;  %[N]

Cl_bestg_sup=sqrt(CD0_sup/pi*AR*e);

TW_supclm=((T-D_sup)/(((W_supphases/S)*S)*9.81))+2*Cl_bestg_sup;

%sigma_supclm=rho_ref/rhosup_clm;
%TW_supclm=TW_supclm*sigma_supclm;

% if first==1
%     disp(' ')
%     disp('OUTPUT SUPERSONIC CLIMB')
%     disp(['Speed: ',num2str(Vsup_clm),' m/s'])
%     disp(['Density: ',num2str(rhosup_clm),' kg/m3'])
%     disp(['Density Ratio: ',num2str(sigma_supclm)])
%     disp(['CD,to: ',num2str(CD_to_sup)])
%     disp(['CL,bestg: ',num2str(Cl_bestg_sup)])
%     disp(['T/W: ',num2str(TW_supclm)])
% end
%% WING LOADING AVAILABLE FOR SUPERSONIC
WS_av_sup=W_supphases/S;
end

