function   [t_ut,t_rt,t_ins_def,tlayer_def_ut,tlayer_def_rt,d_ext,Lpax_out,MES_out,MUTW_out,MUTL_out,MRT_out,MRTL_out,...
    L_aircraft,pmax_out,sigmaf_s_out,E_s_out,kins_out,rhoins_out,Ts_out,Lfa,Lcenter,Lreartb,L_tailcone,wt,ht,lt,dintreart,...
    Lreart,hcab,hwing,d_int_out,Vmissing,Vunderfloor,havtank,Lret,pp,SM_s,tlayer] = Tank_Layer_Sizing(d_int, d_ext,pax_utente,Wfuel,Msup,fl5,fl6,t_tot,...
    Lpax_in,MES_in,MUTW_in,MUTL_in,MRT_in,MRTL_in,pmax_in,sigmaf_s_in,E_s_in,kins_in,rhoins_in,Ts_in, first)
%TANK SIZING : WIDTH, LENGTH AND HEIGTH [UNDERFLOOR AND REAR TANK]
%AICRAFT LENGTH: NOSE+CENTER+TAILCONE
%LAYERS: STRUCTURAL AND INSULATION [UNDERFLOOR AND REAR]

%% TANK SIZING
if first==1
    disp(' ')
    disp('                * UNDEFLOOR TANK SIZING *               ')
    MES=input('Insert a value of Margine of Empty space between internal fuselage and wing [%]:');
    MES_out=MES;
    MUTW=input('Insert a value of Margin of Width between fuselage and tank [%]:');
    MUTW_out=MUTW;
    MUTL=input('Insert a value of Margin of Length between fuselage and tank  [%]:');
    MUTL_out=MUTL;
end

if first==0
    MES=MES_in;
    MES_out=MES_in;
    %MES=1;                                     %[%] Margin of empty space
    
    MUTW=MUTW_in;
    MUTW_out=MUTW_in;
    %MUTW=1;                                   %[%] MARGIN FOR WIDTH OF UNDERFLOOR TANK
    
    MUTL_out=MUTL_in;
    MUTL=MUTL_in;
    %MUTL=1;                                   %MARGIN FOR LENGTH OF UNDERFLOOR TANK
end


hcab=d_int/2;         %[m] Cabin heigth [Assumption]
hwing=0.5;            %[m] Wing heigth [Assumption]
hempty=MES/100*d_int; %[m] Empty space between internal fuselage and wing [Assumption]
havtankmin=1.5;      %[m] [Assumption]
Ddint=0.001;         %[m]

havtank=d_int-(hcab+hwing+hempty);  %[m]

while havtank < havtankmin
    
    d_int=d_int+Ddint;
    hcab=d_int/2;
    hempty=MES/100*d_int;
    havtank=d_int-(hcab+hwing+hempty);
    
end
d_int_out=d_int;
d_ext=d_int+0.5;                      %[m] external diameter
wcab=(d_int*hcab)/(d_int/2);          %[m] cabin floor width
wtank=2*sqrt((d_int/2)^2-havtank^2);  %[m] width of upper part of wing windth HP: CABIN FLOOR IS AT AN HALF OF FUSELAGE

if first==1
    disp(' ')
    disp('Fuselage Cross Sectional Area Heigth Check:')
    disp(['New Fuselage Internal Diameter (d_int): ',num2str(d_int),' m'])
    disp(['Cabin heigth (hcab):',num2str(hcab),' m'])
    disp(['Wing heigth (hwing):',num2str(hwing),' m'])
    disp(['Empty heigth (hvuoto):',num2str(hempty),' m'])
    disp(['Available Tank heigth (havtank):',num2str(havtank),' m'])
    disp(['dint=hcab+havtank+hwing+hvuoto --> ',num2str(d_int-(hcab+havtank+hwing+hempty))])
end

    
%% SIZING OF UNDERFLOOR TANKS THROUGTH CHECK DIMESIONS (WIDTH AND HEIGTH): 'BOMBATED' SHAPE

% HP: TANK IS CENTERED AT: x=0   & y=havtank/2

tlayer=0.08;                              %[m] maximum thickness acceptable 
Dhtank=0.001;                             %[m]
wcheck=2*sqrt((d_int/2)^2-(havtank/2)^2);  %[m]
htank=havtank;

if (wtank+htank+2*tlayer) > (wcheck-wcheck*MUTW/100)
   
    while (wtank+htank+2*tlayer) > (wcheck-wcheck*MUTW/100)
        htank=htank-Dhtank; %[m]
    end

end
if first==1
    disp(' ')
    disp(['Heigth (htank):',num2str(htank),' m'])
    disp(['Tank Width (htank+wtank):',num2str(htank+wtank),' m'])
    disp(['Width Check (wcheck-(htank+wtank+2*tlayer)):',num2str(wcheck-(htank+wtank+2*tlayer)),' m'])
    disp(['Height Check(havtank-(htank+2*tlayer)):',num2str(havtank-(htank+2*tlayer)),' m'])
    %disp(['wcheck-wt --> ',num2str(wcheck-(htank+wtank))])
end



%% LENGTH OF PASSENGERS COMPARTMENT

N_pax = pax_utente;                  % Number of passengers 

if first==1
    disp(' ')
    disp('             * PASSENGERS COMPARTMENT LENGTH *               ')

    %L_seat=input('Insert a value of Seats Length [mm]':)
    L_seat = 850;                        %[mm] [estimation] Seat pitch  
    %seats_abreast=input('Insert a seats abreast:')
    seats_abreast =4;            %case study: 4[aerodynamics]
    N_row = round(N_pax/seats_abreast);
    
    %L_galley=input('Insert a value of Galley/Toilet Length [mm]':)
    L_galley = 980;                   %[mm] [estimation]  Galley/Toilet length
    %N_galley=input('Insert a number of galley/toilet:')
    N_galley = 2;             %case study: 2 [estimation: one in the front and one in the rear of fuselage] Galley/Toilet  number
    
    % Emergency exit length and number
    %For a passenger seating  configuration of 41 to 110
    %seats, there must be at least two
    %exits, one of which  must be a Type I  or larger exit,
    %on  each side of the fuselage.
    
    %L_emergencyexit=input('Insert a value of Emergency Exit Length [mm]':)
    L_emergencyexit = 610; %[mm]
    %N_emergencyexit =input('Insert a number for emergency exit (one side):');   % CS 25: at least two for each side
    N_emergencyexit=2;
    
    Lpax=(N_row*L_seat+N_galley*L_galley+N_emergencyexit*L_emergencyexit)*1e-3; %[m]
    disp(['Passenger Compartament Length:',num2str(Lpax),' m'])
    Lpax_out=Lpax;
end

if first==0
    Lpax=Lpax_in;
    Lpax_out=Lpax_in;
end

%% VOLUME OF UNDERFLOOR TANKS  (volume of fuel can be stored)

%RECTANGULAR PART
Sret=wtank*htank;                        %[m2] rectangular base area
Lret=Lpax/3*(1-MUTL/100)-htank-2*tlayer; %[m]  length of rectangular base area
Vtankret=Sret*Lret;                       %[m3] volume of rectangular base area

%CILINDRICAL PART IN WIDTH DIMESION
Vcilw=pi*(htank/2)^2*wtank;         %[m3] volume of cilindrical area in width dimesion

%CILINDRICAL PART IN LENGTH DIMESION
VcilLret=pi*(htank/2)^2*Lret;       %[m3] volume of cilindrical area in length dimension

%SPHERICAL PART IN EDGES
Vsp=4/3*pi*(htank/2)^3;             %[m3] volume of the sphere (quarter sphere*4edge) 

Vtot=Vtankret+Vcilw+VcilLret+Vsp;    %[m3] total volume of underfloor tank

wt=wtank+htank;                      %[m] Tank width 
ht=htank;                            %[m] Tank heigth
lt=Lret+htank;                       %[m] Tank length
Vst=Vtot;                           %[m] Tank volume 

%% REAR TANK SIZING
if first==1
    disp(' ')
    disp('                * REAR TANK SIZING *               ')
    MRT=input('Insert a value of Margin  between wing and rear tank  [%]:');
    MRT_out=MRT;
    MRTL=input('Insert a value of Margin  between passengers compartment and rear tank  [%]:');
    MRTL_out=MRT;
    %MRTL=1;
    
end
if first==0
    MRT=MRT_in;
    MRT_out=MRT_in;
    %MRT=1;                           %MARGIN REAR TANK
    MRTL=MRTL_in;
    MRTL_out=MRTL_in;
end

rhoLH2=70.8;           %[kg/m3] density
Vfuel=Wfuel/rhoLH2;   %[m3] Volume of misison fuel 

Vunderfloor=Vst*3;     %[m3] Volume of fuel stored in underfloor tank 

Vmissing=Vfuel-Vunderfloor;      %[m3] Volume of fuel missing to allocate

rintreart=d_int/2-(hempty+hwing); %[m] 
hcheck=d_int/2-(hempty+hwing);    %[m]
Drintreart=0.001;                %[m]

while (rintreart+tlayer) > hcheck*(1-MRT/100)
    rintreart=rintreart-Drintreart;
end

dintreart=2*rintreart;

Lreart=(Vmissing-4/3*pi*(dintreart/2)^3)/(pi*(dintreart/2)^2); %[m] Length of cilindrical part of rear  tank
Lreart=Lreart+dintreart;                                       %[m] Total rear tank length

if first==1
    disp(['Rear Tank Heigth/Width/Diameter: ',num2str(dintreart),' m'])
    disp(['Rear Tank Length: ',num2str(Lreart),' m'])
    disp(['Rear Tank Fuel Volume Stored: ',num2str(Vmissing),' m'])
    disp(['Check Heigth (bottom part): ',num2str(hcheck-rintreart-tlayer),' m'])
end

%% AIRCRAFT LENGTH
if first==1
    disp(' ')
    disp('             * AIRCRAFT LENGTH *               ')
end

%% FRONT AREA OR NOSE: AVIONIC BAY + COCKPIT
M=Msup;

mu=asin(1/M);           %[rad]

Lfa=d_ext/(2*tan(mu/2)); %[m] Front area length

%%  TAIL CONE
%FR=input('Insert a value of tailcone fineness ratio (tailconelength/external diameter of fuselage) []':)
FR=2; % tailcone fineness ratio {to reduce drag}: tailconelength/external diameter of fuselage

L_tailcone=FR*d_ext; %[m]

%% CENTRAL PART OF FUSELAGE 
Lreartb=Lreart+2*tlayer+Lreart*MRTL/100; %[m] Rear tank bay length
Lcenter=Lpax+Lreartb;
L_aircraft=Lcenter+L_tailcone+Lfa;       %[m] Aircraft length

if first==1
    
    disp(['Fuselage Center Lenth:',num2str(Lcenter)]);
    disp(['Tailcone Length:',num2str(L_tailcone)])
    disp(['Avionic bay+Cockpit (Frontal Area) Length:',num2str(Lfa)])
    disp(['Aircraft Length:',num2str(L_aircraft)])

end

%% STRUCTURAL AND INSULATION LAYER SIZING

%% STRUCTURAL
if first==1
    disp(' ')
    disp('                  * STRUCTURAL LAYER SIZING *                  ')

    disp(' ')
    disp('Do you want insert a value of Maximum pressure to design tank?')
    disp('!!! ATTENTION:If you choice is NO the pmax is setting equal to 1.5 bar (0.15 Mpa)!!!')
    disp('1.YES   2.NO')
    c_pmax=input('');
    
    if c_pmax==1
        pmax=input('Insert value of pressure in Mpa:');
        pmax_out=pmax;
    end
    
    if c_pmax==2
        pmax=0.15;                                     %[MPa] paper : 1.5 bar
        pmax_out=pmax;
    end
end

if first==0
    pmax=pmax_in;
    pmax_out=pmax_in;
end

hc=(fl5+fl6)/2;                                        %[m] Medium Supersonic cruise altitude
patm=(22557.74*exp(-(hc-11000)/6341.33))*1e-6;         %[MPa] Atmospheric pressure

Dp=pmax-patm;          %[MPa]
pdes=1.1*Dp;           %[MPa] limit design pressure 
pult=1.5*pdes;         %[MPa] ultimate pressure [MPa]
pp=2*pult;             %[MPa] burst pressure
t = 0.001:0.001:0.1;   %[m] thickness' variation from 1mm to 1cm

%MATERIAL DATABASE

%DRA parameters: 
sigmaf_s_DRA=540; %[MPa] 
E_s_DRA=270000;   %[MPa]
%rho_s_DRA=2700;   %[kg/m3]

%Al parameters:
sigmaf_s_Al=105; %[Mpa]
E_s_Al=70000;   %[Mpa]
%rho_s_Al=2700;  %[kg/m3]

%CFRP parameters:
sigmaf_s_CFRP=800; %[Mpa]
E_s_CFRP=50000;   %[Mpa]
%rho_s_CFRP=2000;  %[kg/m3]

%CHOICE OF MATERIAL AND PROPERTIES
if first==1
    disp(' ')
    disp('Do you want choce structural material (DRA,Al or CFRP) or insert a new one?')
    disp(' ')
    disp('1. Choice between DRA,Al or CFRP')
    disp(['DRA: Strength limit :',num2str(sigmaf_s_DRA),' Mpa'])
    disp(['     Young modulus :',num2str(E_s_DRA),' Mpa'])
    %disp(['     Density :',num2str(rho_s_DRA),' kg/m3'])
    disp(['Al: Strength limit :',num2str(sigmaf_s_Al),' Mpa'])
    disp(['     Young modulus :',num2str(E_s_Al),' Mpa'])
    %disp(['     Density :',num2str(rho_s_Al),' kg/m3'])
    disp(['CFRP: Strength limit :',num2str(sigmaf_s_CFRP),' Mpa'])
    disp(['     Young modulus :',num2str(E_s_CFRP),' Mpa'])
    %disp(['     Density :',num2str(rho_s_CFRP),' kg/m3'])
    disp(' ')
    disp('2. Insert value of strength limit, Young modulus and density of another material')
    c_mstr=input('');
    
    if c_mstr==1
        disp(' ')
        disp('1.DRA')
        disp('2.Al')
        disp('3.CFRP')
        c_mstr_d=input('');
        
        if c_mstr_d==1
            sigmaf_s=sigmaf_s_DRA;
            E_s=E_s_DRA;
            %rho_s=rho_s_DRA;
            sigmaf_s_out=sigmaf_s;
            E_s_out=E_s;
            %rho_s_out=rho_s;
        end
        
        if c_mstr_d==2
            sigmaf_s=sigmaf_s_Al;
            E_s=E_s_Al;
            %rho_s=rho_s_Al;
            sigmaf_s_out=sigmaf_s;
            E_s_out=E_s;
            %rho_s_out=rho_s;
        end
        
        if c_mstr_d==3
            sigmaf_s=sigmaf_s_CFRP;
            E_s=E_s_CFRP;
            %rho_s=rho_s_CFRP;
            sigmaf_s_out=sigmaf_s;
            E_s_out=E_s;
            %rho_s_out=rho_s;
        end
        
    end  %MATERIAL DATABASE CHOICE
    
    if c_mstr==2
        
         sigmaf_s=input('Insert a value of Strength limit [MPa]:');
         E_s=input('Insert a value of Young Modulus [MPa]:');
         %rho_s=input('Insert a value of Density [kg/m3]:');
         sigmaf_s_out=sigmaf_s;
         E_s_out=E_s;
         %rho_s_out=rho_s;
         
    end  %NEW MATERIAL CHOICE

end

if first==0
    sigmaf_s=sigmaf_s_in;
    E_s= E_s_in;
    %rho_s=rho_s_in;
    sigmaf_s_out=sigmaf_s_in;
    E_s_out=E_s_in;
    %rho_s_out=rho_s_in;
end

SM_s=1.5;   %SAFETY MARGINE STRUCTURAL LAYER

%UNDERFLOOR TANK SECTION
a_ut=wt/2;          % [m] major half-axis 
c_ut=ht/2;          % [m] minor half-axis

f_ut = pp*((a_ut+c_ut)/2./t.*(1+2*(1+3.6*pp/E_s*((a_ut+c_ut)/2./t).^3)*(a_ut-c_ut)/(a_ut+c_ut))+1/2); %[m]

[Y,I] = min(abs(f_ut-sigmaf_s/SM_s)); %intersection point
t_ut=t(I);                            %Position of intersection point : STRUCTURAL THICKNESS 

%REAR TANK SECTION
a_rt=rintreart;        % [m]major half-axis
c_rt=rintreart;        % [m]minor half-axi

f_rt = pp*((a_rt+c_rt)/2./t.*(1+2*(1+3.6*pp/E_s*((a_rt+c_rt)/2./t).^3)*(a_rt-c_rt)/(a_rt+c_rt))+1/2); %[m]

[Y,I] = min(abs(f_rt-sigmaf_s/SM_s)); %intersection point
t_rt=t(I);                            %Position of intersection point : STRUCTURAL THICKNESS

%% INSULATION [WET CASE]

%DATABASE MATERIAL
%AEROGEL 
kins_AE=0.017;      %[W/(m*K)] thermal conductivity material
rhoins_AE=30;       %[kg/m3]   density
%Vacuum Jacket + MLI
kins_VM=0.0003;     %[W/(m*K)] thermal conductivity material
rhoins_VM=30;       %[kg/m3]   density
%% RIDEFINIZIONE DOPO FLOW CHART
flag_mins=1;
flag_noT=0;
cont=0;
while flag_mins==1
    
    if first==1 || flag_noT==1
        
        disp(' ')
        disp('                                     * INSULATION LAYER SIZING *                                     ')
        
        disp(' ')
        disp('Do you want choce insulation material (AEROGEL or VACUUMJACKET+MLI) or insert a new one?')
        disp('1. Choice between AEROGEL and VACUUM JACKET+MLI')
        disp(['AEROGEL: Thermal conductivity :',num2str(kins_AE),' W/(m*K)'])
        disp(['         Density :',num2str(rhoins_AE),' kg/m3'])
        disp(['VACUUM JACKET+MLI: Thermal conductivity :',num2str(kins_VM),' W/(m*K)'])
        disp(['         Density :',num2str(rhoins_VM),' kg/m3'])
        disp(' ')
        disp('2. Insert value of thermal conductuvuty and density of another material')
        
        c_mins=input('');
        
        if c_mins==1
            disp(' ')
            disp('1. AEROGEL')
            disp('2. VACUUM JACKET+MLI')
            c_mins_d=input('');
            
            if c_mins_d==1
                
                %AEROGEL
                kins=kins_AE;      %[W/(m*K)] thermal conductivity material
                rhoins=rhoins_AE;  %[kg/m3]   density
                kins_out=kins;
                rhoins_out=rhoins;
                
            end
            
            if c_mins_d==2
                
                %Vacuum Jacket + MLI
                kins=kins_VM;     %[W/(m*K)] thermal conductivity material
                rhoins=rhoins_VM;       %[kg/m3]   density
                kins_out=kins;
                rhoins_out=rhoins;
                
            end
        end   %CHOICE DATABASE MATERIAL
        
        if c_mins==2
            disp(' ')
            kins=input('Insert a value of thermal conductivity [W/(m*K)]:');
            rhoins=input('Insert a value of density [kg/m3]: ');
            kins_out=kins;
            rhoins_out=rhoins;
        end %CHOICE NEW MATERIAL
        
    end %FIRST ITERATION OR CASE IN WHICH MATERIAL DOESN'T SATISFY CONSTRAINS
    
    if first==0
        kins=kins_in;
        rhoins=rhoins_in;
        kins_out=kins_in;
        rhoins_out=rhoins_in;
    end

tlf=t_tot*60;       %[s] Mission time 
Tlh2=-260+273;      %[K] LH2 temperature
hlh2=461.1*1000;    %[J/kg] heat of evaporation 

alt=0:1:hc;                               %operative altitude of mission from strating altitude to highest altitude
for i=1:length(alt)
    if alt(i)==11000
        pos=i;
    end
    
end

T=zeros(1,length(alt));                   %Temperature vector: 1row x hc+1 column
T(1,1:pos+1)=288.15-0.0065.*alt(1:pos+1); %[K] Troposhere
T(1,pos+2:end)=216.65;                    %[K] Stratosphere 



t_ins=2*sqrt((kins*tlf.*(T-Tlh2))./(hlh2*rhoins));  %[m] thickness

%MAXIMUM THICKNESS AVAILABLE FOR INSULATION FOR UNDERFLOOR TANK
t_maxins_ut=zeros(1,length(t_ins));
t_maxins_ut(:,:)=tlayer-t_ut;

%MAXIMUM THICKNESS AVAILABLE FOR INSULATIO FOR REAR TANK
t_maxins_rt=zeros(1,length(t_ins));
t_maxins_rt(:,:)=tlayer-t_rt;

% disp(['min(tins)',num2str(min(t_ins))]);
% disp(['min(min(t_maxins_ut),min(t_maxins_rt))',num2str(min(min(t_maxins_ut),min(t_maxins_rt)))]);
% pause();

    if min(t_ins) > min(min(t_maxins_ut),min(t_maxins_rt))
        
        disp(' ')
        disp('Any temperature in range soddisfies the requirement.')
        disp('Change material.')
        
        flag_mins=1;  %VARIABLE LOOP TRUE --> LOOP PROCEDES
        flag_noT=1;   %VARIABLE CONDITION --> THE CHOICES BETWEEN DATBASE AND INPUT ARE SHOWN AGAIN
        
    end %MINIMUM OF THE CURVE IS BIGGER THAN MINIMUM CONSTRAIN [CASO III]
    
    if min(t_ins) <= min(min(t_maxins_ut),min(t_maxins_rt))
    
        if max(t_ins) <= min(min(t_maxins_ut),min(t_maxins_rt))
            
            if first==1
                disp(' ')
                disp('All temperatures in operative range satisfy the constrain.')
                disp('Insert an operative temperature to sizing the insulation thichness [C]')
                Tmax=T(1);
                Tmin=T(end);
                disp('Range of acceptable temperature:')
                disp(['Maximum:',num2str(Tmax-273),' C'])
                disp(['Minimum:',num2str(Tmin-273),' C'])
                Ts=input('');
                Ts=Ts+273; %[K]
                Ts_out=Ts;
                t_ins_def=2*sqrt((kins*tlf*(Ts-Tlh2))/(hlh2*rhoins));  %[m] insulation thickness
                tlayer_def_ut=t_ins_def+t_ut;                          %[m] total thickness: structural+insulation UNDERFLOOR TANK
                tlayer_def_rt=t_ins_def+t_rt;                          %[m] total thickness: structural+insulation REAR TANK
                
                flag_noT=0;
                flag_mins=0;
                
            end %FIRST ITERATION
            
            if first==0
                Ts=Ts_in;
                Ts_out=Ts_in;
                
                t_ins_def=2*sqrt((kins*tlf*(Ts-Tlh2))/(hlh2*rhoins));  %[m] insulation thickness
                tlayer_def_ut=t_ins_def+t_ut;                          %[m] total thickness: structural+insulation UNDERFLOOR TANK
                tlayer_def_rt=t_ins_def+t_rt;                          %[m] total thickness: structural+insulation REAR TANK
                
                kins_out=kins_in;
                rhoins_out=rhoins_in;
                
                flag_noT=0;
                flag_mins=0;
            end
            
            
        end  %MAXIMUM OF CURVE IS LESS THAN CONSTRAIN [CASO I]
        
        if max(t_ins)> min(min(t_maxins_ut),min(t_maxins_rt))
            
            if first==1
                
                [Y,I]=min(abs(t_ins-min(min(t_maxins_ut),min(t_maxins_rt)))); %point of intersection
                Tmin=T(end);
                Tmax=T(I);
                disp(' ')
                disp('Not all temperatures in operative range satisfy the constrain.')
                disp('Range of acceptable temperature:')
                disp(['Maximum:',num2str(Tmax-273),' C'])
                disp(['Minimum:',num2str(Tmin-273),' C'])
                disp('Insert an operative temperature to sizing the insulation thichness [C]')
                Ts=input('');
                Ts=Ts+273; %[K]
                Ts_out=Ts;
                t_ins_def=2*sqrt((kins*tlf*(Ts-Tlh2))/(hlh2*rhoins));  %[m] insulation thickness
                tlayer_def_ut=t_ins_def+t_ut;                          %[m] total thickness: structural+insulation UNDERFLOOR TANK
                tlayer_def_rt=t_ins_def+t_rt;                          %[m] total thickness: structural+insulation REAR TANK
                
                flag_noT=0;
                flag_mins=0;
            end %FIRST ITERATION
            
            if first==0
                
                [Y,I]=min(abs(t_ins-min(min(t_maxins_ut),min(t_maxins_rt)))); %point of intersection
                Tmax=T(I);
                Ts=Ts_in;
                
                if Ts <= Tmax
                    
                    %Ts=Ts_in;
                    Ts_out=Ts_in;
                    t_ins_def=2*sqrt((kins*tlf*(Ts-Tlh2))/(hlh2*rhoins));  %[m] insulation thickness
                    tlayer_def_ut=t_ins_def+t_ut;                          %[m] total thickness: structural+insulation UNDERFLOOR TANK
                    tlayer_def_rt=t_ins_def+t_rt;                          %[m] total thickness: structural+insulation REAR TANK
                    
                    kins_out=kins_in;
                    rhoins_out=rhoins_in;
                    
                    flag_noT=0;
                    flag_mins=0;
                end
                
                if Ts > Tmax
                    
                    Ts=Tmax;
                    Ts_out=Tmax;
                    t_ins_def=2*sqrt((kins*tlf*(Ts-Tlh2))/(hlh2*rhoins));  %[m] insulation thickness
                    tlayer_def_ut=t_ins_def+t_ut;                          %[m] total thickness: structural+insulation UNDERFLOOR TANK
                    tlayer_def_rt=t_ins_def+t_rt;                          %[m] total thickness: structural+insulation REAR TANK
                    
                    kins_out=kins_in;
                    rhoins_out=rhoins_in;
                    
                    flag_noT=0;
                    flag_mins=0;
                    
                end
                
                
            end
            
            %flag_mins=0;
            
        end %THE CURVE HAVE AN INTERSECTION  POINT WITH THE CONSTRAINS
        %flag_mins=0;
    end
cont=cont+1;
% disp(['loop insulation:',num2str(cont)])
% disp(['flagmins:',num2str(flag_mins)])
% disp(['flagnoT:',num2str(flag_noT)])
end
end
