function [WS_lnd,WS_it,rho_ref,W_supphases,CLmax_out,Slnd_out,Sa_out,M_it_out,h_it_out] ...
    = WS_RequirementVerification(fl10,CL_sub,CL_sup,fl4,fl5,fl6,W_supr_medium,payload_utente,OEW,MTOW,CLmax_in,...
    Slnd_in,Sa_in,M_it_in,h_it_in,first)
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here
%OUTPUT:  rho_ref(density of supersonic phases)-->TW_RequirementVerification
%
%% SUPEROSNIC MATCHING CHART VARIABLE
%WEIGTH
W_supphases=payload_utente+OEW+W_supr_medium; %[kg]

%DENSITY from strating supersonic climb to ending of supersonic cruise
h_v=fl4:1:fl6;  
%h_v=fl5:1:fl6;
rhom=0; contRHO=0;

for i=1:length(h_v)
    h=h_v(i);
    
    if h<=11000
        rho=(1.226*(1-0.0000226*h)^4.256); %[kg/m3] International Standard Atmosphere - Troposphere
        rhom=rhom+rho;
        contRHO=contRHO+1;
    end
    
    if h>11000
        rho=(0.363*exp(-(h-11000)/6341.33));       %[kg/m3] International Standard Atmosphere - Stratosphere
        rhom=rhom+rho;
        contRHO=contRHO+1;
    end
end
rho_ref=rhom/contRHO;  %medium density

%%
if first==1
    disp(' ')
    disp('                      -LANDING REQUIREMENT- ')

end

%% DENSITY
rhosl=1.225;                            %[kg/m3] density at sea level

if fl10==0                              %AIRPORT AT SEA LEVEL
    rho_lnd=1.225;
    sigma_lnd=rhosl/rho_lnd;                    %density ratio

else
    rho_lnd=1.226*(1-0.0000226*fl10)^4.256; %[kg/m3] International Standard Atmosphere - Troposphere
    sigma_lnd=rhosl/rho_lnd;                    %density ratio

end
%% CL MAX
if first==1
    disp(' ')
    disp('Do you want continue with CL of aerodynamics or setting one for landing phase (CL,max)?')
    disp('1.AERODINAMICS    2.INPUT')
    choice_CL=input('');
    
    if choice_CL==1
        
        CLmax=max(CL_sub,CL_sup);
        CLmax_out=CL_max;
        
    end
    
    if choice_CL==2
        
        disp(' ')
        CLmax=input('CL: ');
        CLmax_out=CLmax;
        
    end
end
if first==0
    CLmax=CLmax_in;
    CLmax_out=CLmax_in;
end

%% RUNWAY LENGTH
if first==1
    disp(' ')
    Slnd=input('Insert a value of lenght runway [m]: ');
    Slnd_out=Slnd;
    
    figure (61)
    Sa_im=imread('Sa.png');
    imshow(Sa_im)
    disp('In FIGURE 61 are showed a typical value of Sa coefficient.')
    %Sa=input('Insert a value Sa [m]: ');
    Sa=304.8;                                           %[m] Airliner-type 3° glidescope
    Sa_out=Sa;
    close figure 61
end

if first==0
    Sa=Sa_in;
    Sa_out=Sa_in;
    Slnd=Slnd_in;
    Slnd_out=Slnd_in;
    
end
%% WING LOADING LANDING - SEA LEVEL AND SUPERSONIC REGIME
sm=1.67;                                                % safety margin
WS_lnd=(((Slnd*sm)-Sa)/5*CLmax)*(1/0.85)*(sigma_lnd); %[kg/m2] Required Wing loading for landing SEA LEVEL

% sigma_suplnd=rho_ref/rho_lnd;
% WS_lnd_sup=(((Slnd*sm)-Sa)/5*CLmax)*(W_supphases/(0.85*MTOW*1e3)); %[kg/m2] Required Wing loading for landing SUPERSONIC PHASES WEIGTH
% WS_lnd_sup=WS_lnd_sup*sigma_suplnd;
disp(' ')
%% OUTPUT
if first==1
    disp(' ')
    disp('OUTPUT SEA LEVEL:')
    disp(['Density: ',num2str(rho_lnd)])
    disp(['Density ratio [SL/PHASE]: ',num2str(sigma_lnd)])
    disp(['CL maximum: ',num2str(CLmax)])
    disp(['Wing loading: ',num2str(WS_lnd)])
    
%     disp(' ')
%     disp('OUTPUT SUPERSONIC PHASES RELATED:')
%     disp(['Density reference: ',num2str(rho_ref)])
%     disp(['Density ratio [REF/PHASE]: ',num2str(rho_ref/rho_lnd)])
%     disp(['Weigth ratio [REF/PHASE]: ',num2str(W_supphases/(0.85*MTOW*1e3))])
    %disp(['Wing loading: ',num2str(WS_lnd_sup)])
end


%%  INSTANTANEOUS TURN SUBSONIC
if first==1
    disp('                        -INSTANTANEOUS TURN REQUIREMENT- ')
    
    %% INPUT
    disp(' ')
    M_it=input('Insert a value of Mach for turn: ');
    M_it_out=M_it;
    disp(' ')
    h_it=input('Insert an altitude for turn [m]:');
    h_it_out=M_it;
end

if first==0
    M_it=M_it_in;
    M_it_out=M_it_in;
    h_it=h_it_in;
    h_it_out=h_it_in;
end

%% DENSITY AND SPEED
if h_it<=11000
    rho_it=1.226*(1-0.0000226*h_it)^4.256;           %[kg/m3] International Standard Atmosphere - Troposphere
    sigma_it=rhosl/rho_it;
end
if h_it>11000
    rho_it=0.363*exp(-(h_it-11000)/6341.33);       %[kg/m3] International Standard Atmosphere - Stratosphere
    sigma_it=rhosl/rho_it;
end

M=M_it;
h=h_it;
[V] = Speed(h,M);
V_it=V;
%% WING LOADING INSTANTANEOUS TURN
phi=(3*pi)/180;                               %[rad/s] turn rateo
n=sqrt(1+((V_it*phi)/9.81)^2);                 %Load factor

WS_it=((0.5*rho_it*V_it^2*CLmax)/(n*9.81));    %[kg/m2] Required Wing loading for instantaneous turn at turn altitude
WS_it=WS_it*sigma_it;                          %[kg/m2] Required Wing loading for instantaneous turn at turn altitude SEA LEVEL

% sigma_supit=rho_ref/rho_it;
% WS_it_sup=((0.5*rho_it*V_it^2*CLmax)/(n*9.81))*(W_supphases/(MTOW*1e3));    %[kg/m2] Required Wing loading for instantaneous turn at turn altitude SUPERSONIC PHASES RELATED WEIGTH
% WS_it_sup=WS_it_sup*sigma_supit;  %[kg/m2] Required Wing loading for instantaneous turn at turn altitude SUPERSONIC PHASES RELATED ALTITUDE
%% OUTPUT
if first==1
    disp(' ')
    disp('OUTPUT SEA LEVEL :')
    disp(['Density: ',num2str(rho_it)])
    disp(['Density ratio [SL/PHASE]: ',num2str(sigma_it)])
    disp(['CL maximum: ',num2str(CLmax)])
    disp(['Turn speed: ',num2str(V_it),' m/s'])
    disp(['Load factor: ',num2str(n)])
    disp(['Wing loading: ',num2str(WS_it)])
    
%     disp(' ')
%     disp('OUTPUT SUPERSONIC PHASES RELATED:')
%     disp(['Density reference: ',num2str(rho_ref)])
%     disp(['Density ratio [REF/PHASE]: ',num2str(rho_ref/rho_it)])
%     disp(['Weigth ratio [REF/PHASE]: ',num2str(W_supphases/(MTOW*1e3))])
%     disp(['Wing loading: ',num2str(WS_it_sup)])
end


end

